        SUBROUTINE ABMUL(NRADEC,NRAACT,NCBDEC,NCBACT,NCDEC ,NCACT ,
     $                   AMAT  ,BMAT  ,CMAT  ,AROW)
C
C       FEB. 8, 1991
C
C       MATRIX MULTIPLICATION AB=C
C
C       VERSION WITH INNER LOOP UNROLLED TO DEPTHS 32, 16, 8 AND 4
C       EACH ROW OF MATRIX A IS SAVED AS A COLUMN, AROW, BEFORE USE.
C
C       NRADEC IS 1ST DIM. OF AMAT; NRAACT IS ACTUAL LIMIT FOR 1ST INDEX
C       NCBDEC IS 2ND DIM. OF BMAT; NCBACT IS ACTUAL LIMIT FOR 2ND INDEX
C       NCDEC IS COMMON DIMENSION OF AMAT & BMAT; NCACT IS ACTUAL LIMIT
C
C       I.E. NRADEC IS THE NUMBER OF ROWS OF A DECLARED
C            NCBDEC IS THE NUMBER OF COLUMNS OF B DECLARED
C            NCDEC IS THE COMMON DECLARED DIMENSION
C
C       MODIFICATION OF MATRIX MULTIPLIER DONATED BY PROF. JAMES
C       MACKINNON, QUEEN'S UNIVERSITY, KINGSTON, ONTARIO, CANADA
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION AMAT(NRADEC,NCDEC)  ,BMAT(NCDEC,NCBDEC),
     $            CMAT(NRADEC,NCBDEC) ,AROW(NCDEC)
        DATA ZERO /0.0D0/
C
C       FIND NUMBER OF GROUPS OF SIZE 32, 16 ...
C
        NCC32=NCACT/32
        NCC32R=NCACT-32*NCC32
        NCC16=NCC32R/16
        NCC16R=NCC32R-16*NCC16
        NCC8=NCC16R/8
        NCC8R=NCC16R-8*NCC8
        NCC4=NCC8R/4
        NCC4R=NCC8R-4*NCC4
C
C       REASSIGN ROWS TO VECTOR AROW.
C
        DO 100 I=1,NRAACT
           K=0
           IF(NCC32.GT.0) THEN
              DO 200 KK=1,NCC32
                 K=K+32
                 AROW(K-31)=AMAT(I,K-31)
                 AROW(K-30)=AMAT(I,K-30)
                 AROW(K-29)=AMAT(I,K-29)
                 AROW(K-28)=AMAT(I,K-28)
                 AROW(K-27)=AMAT(I,K-27)
                 AROW(K-26)=AMAT(I,K-26)
                 AROW(K-25)=AMAT(I,K-25)
                 AROW(K-24)=AMAT(I,K-24)
                 AROW(K-23)=AMAT(I,K-23)
                 AROW(K-22)=AMAT(I,K-22)
                 AROW(K-21)=AMAT(I,K-21)
                 AROW(K-20)=AMAT(I,K-20)
                 AROW(K-19)=AMAT(I,K-19)
                 AROW(K-18)=AMAT(I,K-18)
                 AROW(K-17)=AMAT(I,K-17)
                 AROW(K-16)=AMAT(I,K-16)
                 AROW(K-15)=AMAT(I,K-15)
                 AROW(K-14)=AMAT(I,K-14)
                 AROW(K-13)=AMAT(I,K-13)
                 AROW(K-12)=AMAT(I,K-12)
                 AROW(K-11)=AMAT(I,K-11)
                 AROW(K-10)=AMAT(I,K-10)
                 AROW(K-9)=AMAT(I,K-9)
                 AROW(K-8)=AMAT(I,K-8)
                 AROW(K-7)=AMAT(I,K-7)
                 AROW(K-6)=AMAT(I,K-6)
                 AROW(K-5)=AMAT(I,K-5)
                 AROW(K-4)=AMAT(I,K-4)
                 AROW(K-3)=AMAT(I,K-3)
                 AROW(K-2)=AMAT(I,K-2)
                 AROW(K-1)=AMAT(I,K-1)
                 AROW(K)=AMAT(I,K)
200           CONTINUE
           END IF
           IF(NCC16.GT.0) THEN
              DO 300 KK=1,NCC16
                 K=K+16
                 AROW(K-15)=AMAT(I,K-15)
                 AROW(K-14)=AMAT(I,K-14)
                 AROW(K-13)=AMAT(I,K-13)
                 AROW(K-12)=AMAT(I,K-12)
                 AROW(K-11)=AMAT(I,K-11)
                 AROW(K-10)=AMAT(I,K-10)
                 AROW(K-9)=AMAT(I,K-9)
                 AROW(K-8)=AMAT(I,K-8)
                 AROW(K-7)=AMAT(I,K-7)
                 AROW(K-6)=AMAT(I,K-6)
                 AROW(K-5)=AMAT(I,K-5)
                 AROW(K-4)=AMAT(I,K-4)
                 AROW(K-3)=AMAT(I,K-3)
                 AROW(K-2)=AMAT(I,K-2)
                 AROW(K-1)=AMAT(I,K-1)
                 AROW(K)=AMAT(I,K)
300           CONTINUE
           END IF
           IF(NCC8.GT.0) THEN
              DO 400 KK=1,NCC8
                 K=K+8
                 AROW(K-7)=AMAT(I,K-7)
                 AROW(K-6)=AMAT(I,K-6)
                 AROW(K-5)=AMAT(I,K-5)
                 AROW(K-4)=AMAT(I,K-4)
                 AROW(K-3)=AMAT(I,K-3)
                 AROW(K-2)=AMAT(I,K-2)
                 AROW(K-1)=AMAT(I,K-1)
                 AROW(K)=AMAT(I,K)
400           CONTINUE
           END IF
           IF(NCC4.GT.0) THEN
              DO 500 KK=1,NCC4
                 K=K+4
                 AROW(K-3)=AMAT(I,K-3)
                 AROW(K-2)=AMAT(I,K-2)
                 AROW(K-1)=AMAT(I,K-1)
                 AROW(K)=AMAT(I,K)
500           CONTINUE
           END IF
           IF(NCC4R.GT.0) THEN
              DO 600 KK=1,NCC4R
                 K=K+1
                 AROW(K)=AMAT(I,K)
600           CONTINUE
           END IF
C
C          FIND ENTRY FOR MATRIX C USING COLUMN VECTOR AROW.
C
           DO 700 J=1,NCBACT
              SUM=ZERO
              K=0
              IF(NCC32.GT.0) THEN
                 DO 800 KK=1,NCC32
                    K=K+32
                    SUM=SUM
     $              +AROW(K-31)*BMAT(K-31,J)+AROW(K-30)*BMAT(K-30,J)
     $              +AROW(K-29)*BMAT(K-29,J)+AROW(K-28)*BMAT(K-28,J)
     $              +AROW(K-27)*BMAT(K-27,J)+AROW(K-26)*BMAT(K-26,J)
     $              +AROW(K-25)*BMAT(K-25,J)+AROW(K-24)*BMAT(K-24,J)
                    SUM=SUM
     $              +AROW(K-23)*BMAT(K-23,J)+AROW(K-22)*BMAT(K-22,J)
     $              +AROW(K-21)*BMAT(K-21,J)+AROW(K-20)*BMAT(K-20,J)
     $              +AROW(K-19)*BMAT(K-19,J)+AROW(K-18)*BMAT(K-18,J)
     $              +AROW(K-17)*BMAT(K-17,J)+AROW(K-16)*BMAT(K-16,J)
                    SUM=SUM
     $              +AROW(K-15)*BMAT(K-15,J)+AROW(K-14)*BMAT(K-14,J)
     $              +AROW(K-13)*BMAT(K-13,J)+AROW(K-12)*BMAT(K-12,J)
     $              +AROW(K-11)*BMAT(K-11,J)+AROW(K-10)*BMAT(K-10,J)
     $              +AROW(K-9) *BMAT(K-9,J) +AROW(K-8) *BMAT(K-8,J)
                    SUM=SUM
     $              +AROW(K-7)*BMAT(K-7,J)+AROW(K-6)*BMAT(K-6,J)
     $              +AROW(K-5)*BMAT(K-5,J)+AROW(K-4)*BMAT(K-4,J)
     $              +AROW(K-3)*BMAT(K-3,J)+AROW(K-2)*BMAT(K-2,J)
     $              +AROW(K-1)*BMAT(K-1,J)+AROW(K)  *BMAT(K,J)
800              CONTINUE
              END IF
              IF(NCC16.GT.0) THEN
                 DO 900 KK=1,NCC16
                    K=K+16
                    SUM=SUM
     $              +AROW(K-15)*BMAT(K-15,J)+AROW(K-14)*BMAT(K-14,J)
     $              +AROW(K-13)*BMAT(K-13,J)+AROW(K-12)*BMAT(K-12,J)
     $              +AROW(K-11)*BMAT(K-11,J)+AROW(K-10)*BMAT(K-10,J)
     $              +AROW(K-9) *BMAT(K-9,J) +AROW(K-8) *BMAT(K-8,J)
                    SUM=SUM
     $              +AROW(K-7)*BMAT(K-7,J)+AROW(K-6)*BMAT(K-6,J)
     $              +AROW(K-5)*BMAT(K-5,J)+AROW(K-4)*BMAT(K-4,J)
     $              +AROW(K-3)*BMAT(K-3,J)+AROW(K-2)*BMAT(K-2,J)
     $              +AROW(K-1)*BMAT(K-1,J)+AROW(K)  *BMAT(K,J)
900              CONTINUE
              END IF
              IF(NCC8.GT.0) THEN
                 DO 1000 KK=1,NCC8
                    K=K+8
                    SUM=SUM
     $              +AROW(K-7)*BMAT(K-7,J)+AROW(K-6)*BMAT(K-6,J)
     $              +AROW(K-5)*BMAT(K-5,J)+AROW(K-4)*BMAT(K-4,J)
     $              +AROW(K-3)*BMAT(K-3,J)+AROW(K-2)*BMAT(K-2,J)
     $              +AROW(K-1)*BMAT(K-1,J)+AROW(K)  *BMAT(K,J)
1000             CONTINUE
              END IF
              IF(NCC4.GT.0) THEN
                 DO 1100 KK=1,NCC4
                    K=K+4
                    SUM=SUM
     $              +AROW(K-3)*BMAT(K-3,J)+AROW(K-2)*BMAT(K-2,J)
     $              +AROW(K-1)*BMAT(K-1,J)+AROW(K)  *BMAT(K,J)
1100             CONTINUE
              END IF
              IF(NCC4R.GT.0) THEN
                 DO 1200 KK=1,NCC4R
                    K=K+1
                    SUM=SUM+AROW(K)*BMAT(K,J)
1200             CONTINUE
              END IF
              CMAT(I,J)=SUM
700        CONTINUE
100     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE ABMUL.
C
        END
