        SUBROUTINE ASCALX(N,EPSMCH,JAC,SCALEX)
C
C       FEB. 13, 1991
C
C       THIS SUBROUTINE ESTABLISHES SCALING FACTORS FOR THE
C       COMPONENET VECTOR IF ADAPTIVE SCALING IS CHOSEN USING
C       INTEGER ITSCLX.
C
C       NOTE: IN QUASI-NEWTON METHODS THE SCALING FACTORS ARE
C             UPDATED ONLY WHEN THE JACOBIAN IS EVALUATED EXPLI-
C             CITLY.
C
C       SCALING FACTORS ARE DETERMINED FROM THE INFINITY NORMS
C       OF THE COLUMNS OF THE JACOBIAN.
C
C       A MINIMUM TOLERANCE ON THE SCALING FACTOR IS THE SQUARE
C       ROOT OF THE MACHINE PRECISION, SQRTEP.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION JAC(N,N)
        DIMENSION        SCALEX(N)
        DATA ZERO,ONE /0.0D0,1.0D0/
C
        SQRTEP=SQRT(EPSMCH)
C
C       J COUNTS COLUMNS.
C
        DO 100 J=1,N
           AMAX=ZERO
C
C          FIND MAXIMUM ENTRY IN JTH COLUMN.
C
           DO 200 I=1,N
              AMAX=MAX(AMAX,ABS(JAC(I,J)))
200        CONTINUE
C
C          IF A COLUMN IS ALL ZEROS SET AMAX TO ONE.
C
           IF(AMAX.EQ.ZERO) AMAX=ONE
           SCALEX(J)=MAX(AMAX,SQRTEP)
100     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE ASCALX.
C
        END
