        SUBROUTINE ATAMUL(NRADEC,NCADEC,NRAACT,NCAACT,NRBDEC,NCBDEC,
     $                    AMAT  ,BMAT)
C
C       FEB. 8, 1991
C
C       MATRIX MULTIPLICATION:   A^A=B
C
C       VERSION WITH INNER LOOP UNROLLED TO DEPTHS 32, 16, 8 AND 4.
C
C       NRADEC IS NUMBER OF ROWS IN A DECLARED
C       NCADEC IS NUMBER OF COLUMNS IN A DECLARED
C       NRAACT IS THE LIMIT FOR THE 1ST INDEX IN A
C       NCAACT IS THE LIMIT FOR THE 2ND INDEX IN A
C       NRBDEC IS NUMBER OF ROWS IN B DECLARED
C       NCBDEC IS NUMBER OF COLUMNS IN B DECLARED
C
C       MODIFIED VERSION OF THE MATRIX MULTIPLIER DONATED BY PROF. JAMES
C       MACKINNON, QUEEN'S UNIVERSITY, KINGSTON, ONTARIO, CANADA
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION AMAT(NRADEC,NCADEC), BMAT(NRBDEC,NCBDEC)
        DATA ZERO /0.0D0/
C
C       FIND NUMBER OF GROUPS OF SIZE 32, 16 ...
C
        NCC32=NRAACT/32
        NCC32R=NRAACT-32*NCC32
        NCC16=NCC32R/16
        NCC16R=NCC32R-16*NCC16
        NCC8=NCC16R/8
        NCC8R=NCC16R-8*NCC8
        NCC4=NCC8R/4
        NCC4R=NCC8R-4*NCC4
C
C       FIND ENTRY IN MATRIX B.
C
        DO 100 I=1,NCAACT
           DO 200 J=I,NCAACT
              SUM=ZERO
              K=0
              IF(NCC32.GT.0) THEN
                 DO 300 KK=1,NCC32
                    K=K+32
                    SUM=SUM
     $              +AMAT(K-31,I)*AMAT(K-31,J)+AMAT(K-30,I)*AMAT(K-30,J)
     $              +AMAT(K-29,I)*AMAT(K-29,J)+AMAT(K-28,I)*AMAT(K-28,J)
     $              +AMAT(K-27,I)*AMAT(K-27,J)+AMAT(K-26,I)*AMAT(K-26,J)
     $              +AMAT(K-25,I)*AMAT(K-25,J)+AMAT(K-24,I)*AMAT(K-24,J)
                    SUM=SUM
     $              +AMAT(K-23,I)*AMAT(K-23,J)+AMAT(K-22,I)*AMAT(K-22,J)
     $              +AMAT(K-21,I)*AMAT(K-21,J)+AMAT(K-20,I)*AMAT(K-20,J)
     $              +AMAT(K-19,I)*AMAT(K-19,J)+AMAT(K-18,I)*AMAT(K-18,J)
     $              +AMAT(K-17,I)*AMAT(K-17,J)+AMAT(K-16,I)*AMAT(K-16,J)
                    SUM=SUM
     $              +AMAT(K-15,I)*AMAT(K-15,J)+AMAT(K-14,I)*AMAT(K-14,J)
     $              +AMAT(K-13,I)*AMAT(K-13,J)+AMAT(K-12,I)*AMAT(K-12,J)
     $              +AMAT(K-11,I)*AMAT(K-11,J)+AMAT(K-10,I)*AMAT(K-10,J)
     $              +AMAT(K-9,I)*AMAT(K-9,J)  +AMAT(K-8,I)*AMAT(K-8,J)
                    SUM=SUM
     $              +AMAT(K-7,I)*AMAT(K-7,J)+AMAT(K-6,I)*AMAT(K-6,J)
     $              +AMAT(K-5,I)*AMAT(K-5,J)+AMAT(K-4,I)*AMAT(K-4,J)
     $              +AMAT(K-3,I)*AMAT(K-3,J)+AMAT(K-2,I)*AMAT(K-2,J)
     $              +AMAT(K-1,I)*AMAT(K-1,J)+AMAT(K,I)  *AMAT(K,J)
300              CONTINUE
              END IF
              IF(NCC16.GT.0) THEN
                 DO 400 KK=1,NCC16
                    K=K+16
                    SUM=SUM
     $              +AMAT(K-15,I)*AMAT(K-15,J)+AMAT(K-14,I)*AMAT(K-14,J)
     $              +AMAT(K-13,I)*AMAT(K-13,J)+AMAT(K-12,I)*AMAT(K-12,J)
     $              +AMAT(K-11,I)*AMAT(K-11,J)+AMAT(K-10,I)*AMAT(K-10,J)
     $              +AMAT(K-9,I)*AMAT(K-9,J)  +AMAT(K-8,I) *AMAT(K-8,J)
                    SUM=SUM
     $              +AMAT(K-7,I)*AMAT(K-7,J)+AMAT(K-6,I)*AMAT(K-6,J)
     $              +AMAT(K-5,I)*AMAT(K-5,J)+AMAT(K-4,I)*AMAT(K-4,J)
     $              +AMAT(K-3,I)*AMAT(K-3,J)+AMAT(K-2,I)*AMAT(K-2,J)
     $              +AMAT(K-1,I)*AMAT(K-1,J)+AMAT(K,I)*AMAT(K,J)
400              CONTINUE
              END IF
              IF(NCC8.GT.0) THEN
                 DO 500 KK=1,NCC8
                    K=K+8
                    SUM=SUM
     $              +AMAT(K-7,I)*AMAT(K-7,J)+AMAT(K-6,I)*AMAT(K-6,J)
     $              +AMAT(K-5,I)*AMAT(K-5,J)+AMAT(K-4,I)*AMAT(K-4,J)
     $              +AMAT(K-3,I)*AMAT(K-3,J)+AMAT(K-2,I)*AMAT(K-2,J)
     $              +AMAT(K-1,I)*AMAT(K-1,J)+AMAT(K,I)*AMAT(K,J)
500              CONTINUE
              END IF
              IF(NCC4.GT.0) THEN
                 DO 600 KK=1,NCC4
                    K=K+4
                    SUM=SUM
     $              +AMAT(K-3,I)*AMAT(K-3,J)+AMAT(K-2,I)*AMAT(K-2,J)
     $              +AMAT(K-1,I)*AMAT(K-1,J)+AMAT(K,I)*AMAT(K,J)
600              CONTINUE
              END IF
              IF(NCC4R.GT.0) THEN
                 DO 700 KK=1,NCC4R
                    K=K+1
                    SUM=SUM+AMAT(K,I)*AMAT(K,J)
700              CONTINUE
              END IF
              BMAT(I,J)=SUM
              IF(I.NE.J) BMAT(J,I)=BMAT(I,J)
200        CONTINUE
100     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE ATAMUL.
C
        END
