	SUBROUTINE ATAOV(OVERFL,MAXEXP,N,NUNIT,OUTPUT,A,B,SCALEF)
C
C       SEPT. 8, 1991
C
C       THIS SUBROUTINE FINDS THE PRODUCT OF THE TRANSPOSE OF THE
C       MATRIX A AND MATRIX A.  EACH ENTRY IS CHECKED BEFORE BEING
C       ACCEPTED.  IF IT WOULD CAUSE AN OVERFLOW 10**MAXEXP IS
C       INSERTED IN ITS PLACE.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        INTEGER    OUTPUT
	DIMENSION  A(N,N)   ,B(N,N)   ,SCALEF(N)
	LOGICAL    OVERFL   ,WRNSUP
	COMMON/NNES_2/WRNSUP
	DATA ZERO,ONE,TWO,TEN /0.0D0,1.0D0,2.0D0,10.0D0/
C
	EPS=TEN**(-MAXEXP)
        OVERFL=.FALSE.
C
	DO 100 I=1,N
	   DO 200 J=I+1,N
	      SUM=ZERO
	      DO 300 K=1,N
		 IF(LOG10(ABS(A(K,I))+EPS)+LOG10(ABS(A(K,J))+EPS)
     $              +TWO*LOG10(SCALEF(K)).GT.MAXEXP) THEN
		    OVERFL=.TRUE.
		    B(I,J)=SIGN(TEN**MAXEXP,A(K,I))*SIGN(ONE,A(K,J))
		    IF(OUTPUT.GT.2.AND.(.NOT.WRNSUP)) THEN
		       WRITE(NUNIT,1)
1                      FORMAT(T3,'*',T74,'*')
		       WRITE(NUNIT,2) B(I,J)
2                      FORMAT(T3,'*',4X,'WARNING: COMPONENT IN',
     $                 ' MATRIX-MATRIX PRODUCT SET TO ',1PD12.3,
     $                 T74,'*')
		    END IF
		    GO TO 201
		 END IF
		 SUM=SUM+A(K,I)*A(K,J)*SCALEF(K)*SCALEF(K)
300           CONTINUE
	      B(I,J)=SUM
	      B(J,I)=SUM
201           CONTINUE
200        CONTINUE
	   SUM=ZERO
	   DO 400 K=1,N
	      IF(TWO*(LOG10(ABS(A(K,I))+EPS)+LOG10(SCALEF(K))).
     $           GT.MAXEXP) THEN
		 OVERFL=.TRUE.
		 B(I,I)=TEN**MAXEXP
		 IF(OUTPUT.GT.2.AND.(.NOT.WRNSUP)) THEN
		    WRITE(NUNIT,1)
		    WRITE(NUNIT,2) B(I,I)
		 END IF
		 GO TO 401
	      END IF
	      SUM=SUM+A(K,I)*A(K,I)*SCALEF(K)*SCALEF(K)
400        CONTINUE
	   B(I,I)=SUM
401        CONTINUE
100     CONTINUE
	RETURN
C
C       LAST CARD OF SUBROUTINE ATAOV.
C
	END
