        SUBROUTINE BROYUN(OVERFL,MAXEXP,N     ,NUNIT ,OUTPUT,
     $                    EPSMCH,FVEC  ,FVECC ,JAC   ,SCALEX,
     $                    WV1   ,XC    ,XPLUS)
C
C       FEB. 23, 1992
C
C       UPDATE THE JACOBIAN USING BROYDEN'S METHOD.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION JAC(N,N)
        INTEGER          OUTPUT
        DIMENSION        FVEC(N)  ,FVECC(N) ,SCALEX(N),WV1(N)  ,
     $                   XC(N)    ,XPLUS(N)
        LOGICAL          OVERFL
        DATA ZERO,TEN /0.0D0,10.0D0/
C
        EPS=TEN**(-MAXEXP)
        SQRTEP=SQRT(EPSMCH)
C
        DO 100 I=1,N
           WV1(I)=(XPLUS(I)-XC(I))*SCALEX(I)
100     CONTINUE
        CALL TWONRM(OVERFL,MAXEXP,N,EPSMCH,DENOM,WV1)
C
C       IF OVERFLOW WOULD OCCUR MAKE NO CHANGE TO JACOBIAN.
C
        IF(OVERFL.OR.LOG10(DENOM+EPS).GT.MAXEXP/2) THEN
           IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
1             FORMAT(T3,'*',T74,'*')
              WRITE(NUNIT,2)
2             FORMAT(T3,'*',4X,'WARNING: JACOBIAN NOT UPDATED',
     $        ' TO AVOID OVERFLOW IN DENOMINATOR OF',T74,'*')
              WRITE(NUNIT,3)
3             FORMAT(T3,'*',4X,'BROYDEN UPDATE',T74,'*')
           END IF
           RETURN
        ELSE
	   DENOM=DENOM*DENOM
        END IF
C
C       IF DENOM IS ZERO, AVOID OVERFLOW, CONTINUE WITH SAME JACOBIAN.
C
        IF(DENOM.EQ.ZERO) RETURN
C
C       UPDATE JACOBIAN BY ROWS.
C
        DO 200 I=1,N
           SUM=ZERO
           DO 300 J=1,N
              SUM=SUM+JAC(I,J)*(XPLUS(J)-XC(J))
300        CONTINUE
           TEMPI=FVEC(I)-FVECC(I)-SUM
C
C          CHECK TO ENSURE THAT SOME MEANINGFUL CHANGE IS BEING MADE
C          TO THE APPROXIMATE JACOBIAN; IF NOT, SKIP UPDATING ROW I.
C
           IF(ABS(TEMPI).GE.SQRTEP*(ABS(FVEC(I))+ABS(FVECC(I))))
     $        THEN
              TEMPI=TEMPI/DENOM
              DO 400 J=1,N
                 JAC(I,J)=JAC(I,J)+TEMPI*
     $                    (XPLUS(J)-XC(J))*SCALEX(J)*SCALEX(J)
400           CONTINUE
           END IF
200     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE BROYUN.
C
        END
