	SUBROUTINE GRADF(OVERCH,OVERFL,RESTRT,SCLFCH,SCLXCH,JUPDM ,
     $                   MAXEXP,N     ,NUNIT ,OUTPUT,QNUPDM,DELF  ,
     $                   FVECC ,JAC   ,SCALEF,SCALEX,WV1   )
C
C       FEB. 23, 1992
C
C       THIS SUBROUTINE COMPUTES THE GRADIENT OF THE FUNCTION
C
C              F=1/2{SCALEF*FVECC)^(SCALEF*FVECC}
C
C       WHICH IS USED AS THE OBJECTIVE FUNCTION FOR MINIMIZATION.
C
C       NOTE: WHEN THE FACTORED FORM OF THE JACOBIAN IS UPDATED IN
C             QUASI-NEWTON METHODS THE GRADIENT IS UPDATED AS WELL
C             IN THE SAME SUBROUTINE - IT IS PRINTED HERE THOUGH.
C             IN THESE CASES QNUPDM > 0.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION  JAC(N,N)
        INTEGER           OUTPUT  ,QNUPDM
	DIMENSION         DELF(N) ,FVECC(N),SCALEF(N),SCALEX(N),WV1(N)
	LOGICAL           OVERCH  ,OVERFL  ,RESTRT   ,SCLFCH   ,SCLXCH
C
        IF(RESTRT.OR.JUPDM.EQ.0.OR.QNUPDM.EQ.0) THEN
C
C          GRADIENT NOT ALREADY UPDATED:    FIND DELF = J^F.
C
	   DO 100 I=1,N
	      IF(SCLFCH) THEN
		WV1(I)=FVECC(I)*SCALEF(I)*SCALEF(I)
	      ELSE
		WV1(I)=FVECC(I)
	      END IF
100        CONTINUE
	   IF(OVERCH) THEN ! CHECK EACH ENTRY INDIVIDUALLY
	      CALL ATVOV(OVERFL,MAXEXP,N     ,NUNIT ,
     $                   OUTPUT,JAC   ,WV1   ,DELF  )
	   ELSE
	      CALL ATBMUL(N,N,1,1,N,N,JAC,WV1,DELF)
	   END IF
	END IF
C
C       PRINT GRADIENT VECTOR, DELF.
C
	IF(OUTPUT.GT.3) THEN
	   IF(.NOT.SCLXCH) THEN
	      WRITE(NUNIT,1)
1             FORMAT(T3,'*',T74,'*')
	      IF(.NOT.SCLFCH) THEN
		 WRITE(NUNIT,2)
2                FORMAT(T3,'*',4X,'GRADIENT OF OBJECTIVE FUNCTION',
     $           T74,'*')
	      ELSE
		 WRITE(NUNIT,3)
3                FORMAT(T3,'*',4X,'GRADIENT OF SCALED OBJECTIVE',
     $           ' FUNCTION',T74,'*')
	      END IF
	      WRITE(NUNIT,1)
	      DO 300 I=1,N
		 WRITE(NUNIT,4) I,DELF(I)
4                FORMAT(T3,'*',6X,'DELF(',I3,') = ',1PD12.3,T74,'*')
300           CONTINUE
	   ELSE
	      WRITE(NUNIT,1)
	      WRITE(NUNIT,5)
5             FORMAT(T3,'*',4X,'GRADIENT OF OBJECTIVE FUNCTION',9X,
     $        'IN SCALED X UNITS',T74,'*')
	      WRITE(NUNIT,1)
	      DO 400 I=1,N
		 WRITE(NUNIT,6) I,DELF(I),I,SCALEF(I)*SCALEF(I)*
     $           DELF(I)/SCALEX(I)
6                FORMAT(T3,'*',6X,'DELF(',I3,') = ',1PD12.3,
     $           9X,'DELF(',I3,') = ',1PD12.3,T74,'*')
400           CONTINUE
	   END IF
	END IF
        RETURN
C
C       LAST CARD OF SUBROUTINE GRADF.
C
	END
