	SUBROUTINE INITCH(INSTOP,LINESR,NEWTON,OVERFL,SCLFCH,
     $                    SCLXCH,ACPTCR,CONTYP,JACTYP,JUPDM ,
     $                    MAXEXP,N     ,NUNIT ,OUTPUT,QNUPDM,
     $                    STOPCR,TRUPDM,EPSMCH,FCNOLD,FTOL  ,
     $                    BOUNDL,BOUNDU,FVECC ,SCALEF,SCALEX,
     $                    WV1   ,XC    ,FVECEV)
C
C       AUG. 27, 1991
C
C       THIS SUBROUTINE FIRST CHECKS TO SEE IF N IS WITHIN THE
C       ACCEPTABLE RANGE.
C
C       THE SECOND CHECK IS TO SEE IF THE INITIAL ESTIMATE IS
C       ALREADY A SOLUTION BY THE FUNCTION VALUE CRITERION, FTOL.
C
C       THE THIRD CHECK IS MADE TO SEE IF THE NEWTON OPTION IS BEING
C       USED WITH THE LINE SEARCH.  IF NOT A WARNING IS GIVEN AND
C       THE LINE SEARCH OPTION IS INVOKED.
C
C       THE FOURTH CHECK IS TO ENSURE APPLICABILITY OF SELECTED
C       VALUES FOR INTEGER CONSTANTS.
C
C       THE FIFTH CHECK IS TO WARN THE USER IF INITIAL ESTIMATES
C       ARE NOT WITHIN THE RANGES SET BY THE BOUNDL AND BOUNDU
C       VECTORS. CONTYP IS CHANGED FROM 0 TO 1 IF ANY BOUND HAS
C       BEEN SET BY THE USER
C
C       THE SIXTH CHECK ENSURES BOUNDL(I) < BOUNDU(I) FOR ALL I.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        INTEGER           ACPTCR   ,CONTYP   ,OUTPUT   ,QNUPDM   ,
     $                    STOPCR   ,TRUPDM
        DIMENSION         BOUNDL(N),BOUNDU(N),FVECC(N) ,SCALEF(N),
     $                    SCALEX(N),WV1(N)   ,XC(N)
        LOGICAL           FRSTER   ,INSTOP   ,LINESR   ,NEWTON   ,
     $                    OVERFL   ,SCLFCH   ,SCLXCH
        EXTERNAL FVECEV
	DATA ZERO,ONE,TEN /0.0D0,1.0D0,10.0D0/
C
        INSTOP=.FALSE.
        TEMP1=-TEN**MAXEXP
        TEMP2=TEN**MAXEXP
C
C       CHECK FOR N IN RANGE.
C
        IF(N.LE.0) THEN
           INSTOP=.TRUE.
           WRITE(NUNIT,1)
1          FORMAT(T3,72('*'))
           WRITE(NUNIT,2)
2          FORMAT(T3,'*',T74,'*')
           WRITE(NUNIT,3)
3          FORMAT(T3,'*',2X,'N IS OUT OF RANGE - RESET TO POSITIVE',
     $     ' INTEGER',T74,'*')
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
        END IF
C
C       CHECK FOR SCALING FACTORS POSITIVE.
C
	FRSTER=.TRUE.
	SCLFCH=.FALSE.
	SCLXCH=.FALSE.
        DO 100 I=1,N
           IF(SCALEF(I).LE.ZERO) THEN
              IF(FRSTER) THEN
		 INSTOP=.TRUE.
                 FRSTER=.FALSE.
                 WRITE(NUNIT,1)
              END IF
              WRITE(NUNIT,2)
              WRITE(NUNIT,4) I,SCALEF(I)
4             FORMAT(T3,'*',7X,'SCALEF(',I3,') = ',1PD12.3,
     $        4X,'SHOULD BE POSITIVE',T74,'*')
	   END IF
	   IF(SCALEF(I).NE.ONE) SCLFCH=.TRUE.
           IF(SCALEX(I).LE.ZERO) THEN
              IF(FRSTER) THEN
		 INSTOP=.TRUE.
                 FRSTER=.FALSE.
                 WRITE(NUNIT,1)
              END IF
              WRITE(NUNIT,2)
              WRITE(NUNIT,5) I,SCALEX(I)
5             FORMAT(T3,'*',7X,'SCALEX(',I3,') = ',1PD12.3,
     $        4X,'SHOULD BE POSITIVE',T74,'*')
           END IF
	   IF(SCALEX(I).NE.ONE) SCLXCH=.TRUE.
100     CONTINUE
	IF(.NOT.FRSTER) THEN
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
        END IF
C
C       EVALUATE INITIAL RESIDUAL VECTOR AND OBJECTIVE FUNCTION AND
C       CHECK TO SEE IF THE INITIAL GUESS IS ALREADY A SOLUTION.
C
        CALL FVECEV(OVERFL,N,FVECC,XC)
C
C       NOTE: NUMBER OF LINE SEARCH FUNCTION EVALUATIONS, NFUNC,
C             INITIALIZED AT 1 WHICH REPRESENTS THIS EVALUATION.
C
        IF(OVERFL) THEN
           WRITE(NUNIT,1)
           WRITE(NUNIT,2)
           WRITE(NUNIT,6)
6          FORMAT(T3,'*',7X,'OVERFLOW IN INITIAL FUNCTION',
     $     ' VECTOR EVALUATION',T74,'*')
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
           INSTOP=.TRUE.
           RETURN
        END IF
        CALL FCNEVL(OVERFL,MAXEXP,N     ,NUNIT ,OUTPUT,EPSMCH,
     $              FCNOLD,FVECC ,SCALEF,WV1   )
        IF(OVERFL) THEN
           WRITE(NUNIT,1)
           WRITE(NUNIT,2)
           WRITE(NUNIT,7)
7          FORMAT(T3,'*',7X,'OVERFLOW IN INITIAL OBJECTIVE ',
     $     ' FUNCTION EVALUATION',T74,'*')
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
           INSTOP=.TRUE.
           RETURN
        END IF
C
C       CHECK FOR SOLUTION USING SECOND STOPPING CRITERION.
C
	DO 200 I=1,N
	   IF(ABS(FVECC(I)).GT.FTOL) GO TO 201
200     CONTINUE
	INSTOP=.TRUE.
	IF(WRNSUP.EQ.FALSE) THEN
	   WRITE(NUNIT,1)
	   WRITE(NUNIT,2)
	   WRITE(NUNIT,8)
 8	   FORMAT(T3,'*',2X,'WARNING: THIS IS ALREADY A SOLUTION',
	1	' BY THE CRITERIA OF THE SOLVER',T74,'*')
	   WRITE(NUNIT,2)
C
C       IF THE PROBLEM IS BADLY SCALED THE OBJECTIVE FUNCTION
C       MAY MEET THE TOLERANCE ALTHOUGH THE INITIAL ESTIMATE
C       IS NOT THE SOLUTION.
C
	   WRITE(NUNIT,9)
 9	   FORMAT(T3,'*',2X,'THIS MAY POSSIBLY BE ALLEVIATED BY ',
	1	'RESCALING THE PROBLEM IF THE',T74,'*')
	   WRITE(NUNIT,10)
 10	   FORMAT(T3,'*',2X,'INITIAL ESTIMATE IS KNOWN NOT TO BE',
	1	' A SOLUTION',T74,'*')
	   WRITE(NUNIT,2)
	   WRITE(NUNIT,1)
	END IF
201     CONTINUE ! FVEC(I) > FTOL FOR SOME I FROM 200 LOOP
C
C       CHECK FOR NEWTON'S METHOD REQUESTED BUT LINE SEARCH NOT
C       BEING USED.
C
        IF(NEWTON.AND.(.NOT.LINESR)) THEN
           LINESR=.TRUE.
           WRITE(NUNIT,1)
           WRITE(NUNIT,2)
           WRITE(NUNIT,11)
11         FORMAT(T3,'*',2X,'WARNING: INCOMPATIBLE OPTIONS',
     $     ': NEWTON=.TRUE. AND LINESR=.FALSE.',T74,'*')
           WRITE(NUNIT,12)
12         FORMAT(T3,'*',2X,'LINESR SET TO .TRUE.; EXECUTION'
     $     ' OF NEWTON METHOD CONTINUING',T74,'*')
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
        END IF
C
C       CHECK INTEGER CONSTANTS.
C
        IF(ACPTCR.NE.1.AND.ACPTCR.NE.12) THEN
           WRITE(NUNIT,1)
           WRITE(NUNIT,2)
           WRITE(NUNIT,13) ACPTCR
13         FORMAT(T3,'*',2X,'ACPTCR NOT AN ACCEPTABLE VALUE: ',
     $     I5,T74,'*')
           INSTOP=.TRUE.
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
        END IF
        IF(JACTYP.LT.0.OR.JACTYP.GT.3) THEN
           WRITE(NUNIT,1)
           WRITE(NUNIT,2)
           WRITE(NUNIT,14) JACTYP
14         FORMAT(T3,'*',2X,'JACTYP:',I5,' - NOT IN PROPER RANGE',
     $     T74,'*')
           INSTOP=.TRUE.
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
        END IF
        IF(STOPCR.NE.1.AND.STOPCR.NE.12.AND.STOPCR.NE.2.
     $     AND.STOPCR.NE.3) THEN
           WRITE(NUNIT,1)
           WRITE(NUNIT,2)
           WRITE(NUNIT,15) STOPCR
15         FORMAT(T3,'*',2X,'STOPCR NOT AN ACCEPTABLE VALUE: ',
     $     I5,T74,'*')
           INSTOP=.TRUE.
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
        END IF
        IF(QNUPDM.LT.0.OR.QNUPDM.GT.1) THEN
           WRITE(NUNIT,1)
           WRITE(NUNIT,2)
           WRITE(NUNIT,16) QNUPDM
16         FORMAT(T3,'*',2X,'QNUPDM:',I5,' - NOT IN PROPER RANGE',
     $     T74,'*')
           INSTOP=.TRUE.
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
        END IF
        IF(TRUPDM.LT.0.OR.TRUPDM.GT.1) THEN
           WRITE(NUNIT,1)
           WRITE(NUNIT,2)
           WRITE(NUNIT,17) TRUPDM
17         FORMAT(T3,'*',2X,'TRUPDM:',I5,' - NOT IN PROPER RANGE',
     $     T74,'*')
           INSTOP=.TRUE.
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
        END IF
        IF(JUPDM.LT.0.OR.JUPDM.GT.2) THEN
           WRITE(NUNIT,1)
           WRITE(NUNIT,2)
           WRITE(NUNIT,18) JUPDM
18         FORMAT(T3,'*',2X,'JUPDM:',I5,' - NOT IN PROPER RANGE',
     $     T74,'*')
           INSTOP=.TRUE.
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
        END IF
C
C       CHECK FOR INITIAL ESTIMATES NOT WITHIN SPECIFIED BOUNDS AND
C       SET CONTYP TO 1 => AT LEAST ONE BOUND IS IN EFFECT.
C
        CONTYP=0
	DO 300 I=1,N
           IF((BOUNDL(I).NE.TEMP1.OR.BOUNDU(I).NE.TEMP2)) THEN
              CONTYP=1
	      GO TO 301
           END IF
300     CONTINUE
301     CONTINUE
        FRSTER=.TRUE.
        IF(CONTYP.NE.0) THEN
	   DO 400 I=1,N
C
C             CHECK FOR INITIAL ESTIMATES OUT OF RANGE AND LOWER
C             BOUND GREATER THAN OR EQUAL TO THE UPPER BOUND.
C
              IF(XC(I).LT.BOUNDL(I).OR.XC(I).GT.BOUNDU(I)) THEN
		 IF(FRSTER) THEN
		    INSTOP=.TRUE.
		    FRSTER=.FALSE.
		    WRITE(NUNIT,1)
		    WRITE(NUNIT,2)
		    WRITE(NUNIT,19)
19                  FORMAT(T3,'*',7X,'COMPONENTS MUST BE WITHIN',
     $              ' BOUNDS',T74,'*')
		    WRITE(NUNIT,2)
		    WRITE(NUNIT,20)
20                  FORMAT(T3,'*',8X,'NO.',9X,'XC',16X,'BOUNDL',10X,
     $              'BOUNDU',T74,'*')
		    WRITE(NUNIT,2)
                 END IF
		 WRITE(NUNIT,21) I,XC(I),BOUNDL(I),BOUNDU(I)
21               FORMAT(T3,'*',7X,I3,3X,1PD12.3,9X,1PD12.3,4X,
     $           1PD12.3,T74,'*')
              END IF
400        CONTINUE
	   IF(.NOT.FRSTER) THEN
              WRITE(NUNIT,2)
              WRITE(NUNIT,1)
           END IF
C
           FRSTER=.TRUE.
	   DO 500 I=1,N
              IF(BOUNDL(I).GE.BOUNDU(I)) THEN
                 IF(FRSTER) THEN
                    FRSTER=.FALSE.
		    WRITE(NUNIT,1)
		    WRITE(NUNIT,2)
		    WRITE(NUNIT,22)
22                  FORMAT(T3,'*',7X,'LOWER BOUND MUST BE LESS THAN',
     $              ' UPPER BOUND - VIOLATIONS LISTED',T74,'*')
                    WRITE(NUNIT,2)
                 END IF
		 WRITE(NUNIT,23) I,BOUNDL(I),I,BOUNDU(I)
23               FORMAT(T3,'*',7X,'BOUNDL(',I3,') = ',1PD12.3,
     $           4X,'BOUNDU(',I3,') = ',1PD12.3,T74,'*')
              END IF
500        CONTINUE
           IF(.NOT.FRSTER) THEN
              WRITE(NUNIT,2)
              WRITE(NUNIT,1)
           END IF
        END IF
        RETURN
C
C       LAST CARD OF SUBROUTINE INITCH.
C
        END
