        SUBROUTINE JACCD(N     ,NUNIT ,OUTPUT,EPSMCH,FVECJ1,
     $                   FVECJ2,JACFDM,SCALEX,XC    ,FVECEV)
C
C       FEB. 11, 1991
C
C       THIS SUBROUTINE EVALUATES THE JACOBIAN USING CENTRAL
C       DIFFERENCES.
C
C       FVECJ1 AND FVECJ2 ARE TEMPORARY VECTORS TO HOLD THE
C       RESIDUAL VECTORS FOR THE CENTRAL DIFFERENCE CALCULATION.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION JACFDM(N,N)
        INTEGER          OUTPUT
        DIMENSION        FVECJ1(N)   ,FVECJ2(N) ,SCALEX(N) ,XC(N)
        LOGICAL          OVERFL      ,WRNSUP
        COMMON/NNES_2/WRNSUP
        EXTERNAL FVECEV
        DATA ONE,TWO /1.0D0,2.0D0/
C
        OVERFL=.FALSE.
        CURTEP=EPSMCH**0.33
C
        DO 100 J=1,N
           DELTAJ=(CURTEP)*SIGN((MAX(ABS(XC(J)),
     $            ONE/SCALEX(J))),XC(J))
           TEMPJ=XC(J)
           XC(J)=XC(J)+DELTAJ
C
C          NOTE: THIS STEP IS FOR FLOATING POINT ACCURACY ONLY.
C
           DELTAJ=XC(J)-TEMPJ
C
           CALL FVECEV(OVERFL,N,FVECJ1,XC)
           XC(J)=TEMPJ-DELTAJ
           CALL FVECEV(OVERFL,N,FVECJ2,XC)
           IF(OVERFL.AND.OUTPUT.GT.2.AND.(.NOT.WRNSUP)) THEN
              WRITE(NUNIT,1)
1             FORMAT(T3,'*',T74,'*')
              WRITE(NUNIT,2)
2             FORMAT(T3,'*',4X,'WARNING: OVERFLOW IN FUNCTION',
     $        ' VECTOR IN "JACCD"',T74,'*')
           END IF
           DO 200 I=1,N
              JACFDM(I,J)=(FVECJ1(I)-FVECJ2(I))/(TWO*DELTAJ)
200        CONTINUE
           XC(J)=TEMPJ
100     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE JACCD.
C
        END
