	SUBROUTINE LLFA(OVERCH,OVERFL,SCLFCH,SCLXCH,ISEJAC,
     $                  MAXEXP,N     ,NUNIT ,OUTPUT,EPSMCH,
     $                  OMEGA ,A     ,DELF  ,FVEC  ,FVECC ,
     $                  JAC   ,PLEE  ,RDIAG ,S     ,SCALEF,
     $                  SCALEX,T     ,W     ,WV3   ,XC    ,
     $                  XPLUS )
C
C       FEB. 23, 1991
C
C       THE LEE AND LEE QUASI-NEWTON METHOD IS APPLIED TO
C       THE FACTORED FORM OF THE JACOBIAN.
C
C       NOTE: T AND W ARE TEMPORARY WORKING VECTORS ONLY.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DOUBLE PRECISION JAC(N,N)
        INTEGER          OUTPUT
        DIMENSION        A(N,N)   ,DELF(N) ,FVEC(N)  ,FVECC(N) ,
     $                   PLEE(N,N),RDIAG(N),S(N)     ,SCALEF(N),
     $                   SCALEX(N),T(N)    ,W(N)     ,WV3(N)   ,
     $                   XC(N)    ,XPLUS(N)
	LOGICAL          OVERCH   ,OVERFL  ,SCLFCH   ,SCLXCH   ,
     $                   SKIPUP
	DATA ZERO /0.0D0/
C
	OVERFL=.FALSE.
	SQRTEP=SQRT(EPSMCH)
	SKIPUP=.TRUE.
C
        DO 100 I=1,N
	   A(I,I)=RDIAG(I)
           S(I)=XPLUS(I)-XC(I)
100     CONTINUE
C
C       R IS IN THE UPPER TRIANGLE OF A.
C
C       T=RS
C
	CALL UVMUL(N,N,N,N,A,S,T)
C
C       FORM PART OF NUMERATOR AND CHECK TO SEE IF A SIGNIFICANT
C       CHANGE WOULD BE MADE TO THE JACOBIAN.
C
        DO 200 I=1,N
	   CALL INNERP(OVERCH,OVERFL,MAXEXP,N,N,N,NUNIT,OUTPUT,SUM,
     $                 JAC(N*(I-1)+1,1),T)
           W(I)=SCALEF(I)*(FVEC(I)-FVECC(I))-SUM
C
C          TEST TO ENSURE VECTOR W IS NONZERO.  IF W(I)=0 FOR
C          ALL I THEN THE UPDATE IS SKIPPED - SKIPUP IS TRUE.
C
           IF(ABS(W(I)).GT.SQRTEP*SCALEF(I)*(ABS(FVEC(I))+
     $     ABS(FVECC(I)))) THEN
	      SKIPUP=.FALSE.  ! UPDATE TO BE PERFORMED
           ELSE
	      W(I)=ZERO
           END IF
200     CONTINUE
        IF(.NOT.SKIPUP) THEN
C
C          T=Q^W   Q^ IS STORED IN JAC.
C
	   CALL AVMUL(N,N,N,N,JAC,W,T)
C
C          FIND DENOMINATOR; FORM W=S^P (P IS SYMMETRIC SO PS IS FOUND).
C
	   CALL AVMUL(N,N,N,N,PLEE,S,W)
	   IF(SCLXCH) THEN
C
C             SCALE W TO FIND DENOMINATOR.
C
	      DO 300 I=1,N
		 WV3(I)=W(I)*SCALEX(I)*SCALEX(I)
300           CONTINUE
	   ELSE
	      CALL MATCOP(N,N,1,1,N,1,W,WV3)
	   END IF
	   CALL INNERP(OVERCH,OVERFL,MAXEXP,N     ,N     ,N     ,
     $                 NUNIT ,OUTPUT,DENOM ,WV3   ,S     )
C
C          IF OVERFLOW WOULD OCCUR MAKE NO CHANGE TO JACOBIAN.
C
           IF(OVERFL) THEN
              IF(OUTPUT.GT.3) THEN
                 WRITE(NUNIT,1)
1                FORMAT(T3,'*',T74,'*')
                 WRITE(NUNIT,2)
2                FORMAT(T3,'*',4X,'WARNING: JACOBIAN NOT UPDATED',
     $           ' TO AVOID OVERFLOW IN DENOMINATOR OF',T74,'*',
     $           /T3,'*',4X,'LEE AND LEE UPDATE',T74,'*')
              END IF
              RETURN
           END IF
C
C          IF DENOM IS ZERO THE SOLVER IS PROBABLY NEAR SOLUTION -
C          AVOID OVERFLOW AND CONTINUE WITH SAME JACOBIAN.
C
	   IF(DENOM.EQ.ZERO) RETURN
C
C          THE SCALED VERSION OF S IS TAKEN TO THE UPDATE.
C
           DO 400 I=1,N
	      W(I)=W(I)*SCALEX(I)*SCALEX(I)/DENOM
400        CONTINUE
C
C          UPDATE THE QR DECOMPOSITION USING A SERIES OF GIVENS
C          (JACOBI) ROTATIONS.
C
	   CALL QRUPDA(OVERFL,MAXEXP,N,EPSMCH,A,JAC,T,W)
C
C          RESET RDIAG AS DIAGONAL OF CURRENT R WHICH IS IN
C          THE UPPER TRIANGLE OF A.
C
           DO 500 I=1,N
              RDIAG(I)=A(I,I)
500        CONTINUE
C
C          UPDATE P MATRIX
C
           DENOM=OMEGA**(ISEJAC+2)+DENOM
           PLEE(1,1)=PLEE(1,1)-WV3(1)*WV3(1)/DENOM
           DO 600 J=2,N
              DO 700 I=1,J-1
                 PLEE(I,J)=PLEE(I,J)-WV3(I)*WV3(J)/DENOM
                 PLEE(J,I)=PLEE(I,J)
700           CONTINUE
              PLEE(J,J)=PLEE(J,J)-WV3(J)*WV3(J)/DENOM
600        CONTINUE
        END IF
C
C       UPDATE THE GRADIENT VECTOR, DELF.
C
C       DELF = (QR)^F = R^Q^F = R^JAC F
C
	IF(SCLFCH) THEN
	   DO 800 I=1,N
	      W(I)=FVEC(I)*SCALEF(I)
800        CONTINUE
	ELSE
	   CALL MATCOP(N,N,1,1,N,1,FVEC,W)
	END IF
	CALL AVMUL(N,N,N,N,JAC,W,T)
	CALL UTBMUL(N,N,1,1,N,N,A,T,DELF)
        RETURN
C
C       LAST CARD OF SUBROUTINE LLFA.
C
	END

