        SUBROUTINE LLUN(OVERCH,OVERFL,ISEJAC,MAXEXP,N     ,
     $                  NUNIT ,OUTPUT,EPSMCH,OMEGA ,FVEC  ,
     $                  FVECC ,JAC   ,PLEE  ,S     ,SCALEX,
     $                  WV1   ,XC    ,XPLUS)
C
C       FEB. 13, 1991
C
C       UPDATE THE JACOBIAN USING THE LEE AND LEE METHOD.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION JAC(N,N)
        INTEGER          OUTPUT
        DIMENSION        FVEC(N)  ,FVECC(N) ,PLEE(N,N) ,S(N)   ,
     $                   SCALEX(N),WV1(N)   ,XC(N)     ,XPLUS(N)
        LOGICAL          OVERCH   ,OVERFL
        DATA ZERO /0.0D0/
C
        SQRTEP=SQRT(EPSMCH)
C
        DO 100 I=1,N
           S(I)=(XPLUS(I)-XC(I))*SCALEX(I)
100     CONTINUE
        DO 200 I=1,N
           WV1(I)=ZERO
           DO 300 J=1,N
              WV1(I)=WV1(I)+S(J)*PLEE(J,I)
300        CONTINUE
200     CONTINUE
	CALL INNERP(OVERCH,OVERFL,MAXEXP,N     ,N     ,N     ,
     $              NUNIT ,OUTPUT, DENOM,WV1   ,S     )
C
C       IF OVERFLOW WOULD OCCUR MAKE NO CHANGE TO JACOBIAN.
C
        IF(OVERFL) THEN
           IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
1             FORMAT(T3,'*',T74,'*')
              WRITE(NUNIT,2)
2             FORMAT(T3,'*',4X,'WARNING: JACOBIAN NOT UPDATED',
     $        ' TO AVOID OVERFLOW IN DENOMINATOR OF',T74,'*')
              WRITE(NUNIT,3)
3             FORMAT(T3,'*',4X,'LEE AND LEE UPDATE',T74,'*')
           END IF
           RETURN
        END IF
C
C       IF DENOM IS ZERO THE SOLVER MUST BE VERY NEAR SOLUTION -
C       AVOID OVERFLOW AND CONTINUE WITH SAME JACOBIAN.
C
        IF(DENOM.EQ.ZERO) RETURN
        DO 400 I=1,N
           SUM=ZERO
           DO 500 J=1,N
              SUM=SUM+JAC(I,J)*(XPLUS(J)-XC(J))
500        CONTINUE
           TEMPI=FVEC(I)-FVECC(I)-SUM
           IF(ABS(TEMPI).GE.SQRTEP*(ABS(FVEC(I))+ABS(FVECC(I))))
     $        THEN
              TEMPI=TEMPI/DENOM
              DO 600 J=1,N
                 JAC(I,J)=JAC(I,J)+TEMPI*WV1(J)*SCALEX(J)
600           CONTINUE
           END IF
400     CONTINUE
C
C       UPDATE P MATRIX.
C
        DENOM=OMEGA**(ISEJAC+2)+DENOM
        PLEE(1,1)=PLEE(1,1)-WV1(1)*WV1(1)/DENOM
        DO 700 J=2,N
           DO 800 I=1,J-1
              PLEE(I,J)=PLEE(I,J)-WV1(I)*WV1(J)/
     $                  (DENOM*SCALEX(I)*SCALEX(J))
              PLEE(J,I)=PLEE(I,J)
800        CONTINUE
           PLEE(J,J)=PLEE(J,J)-WV1(J)*WV1(J)/DENOM
700     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE LLUN.
C
        END
