        SUBROUTINE MAXST(OVERFL,MAXEXP,N     ,NUNIT ,OUTPUT,EPSMCH,
     $                   MAXSTP,MSTPF ,SCALEX,WV1   ,XC    )
C
C       FEB. 11, 1991
C
C       THIS SUBROUTINE ESTABLISHES A MAXIMUM STEP LENGTH BASED ON
C       THE 2-NORMS OF THE INITIAL ESTIMATES AND THE SCALING FACTORS
C       MULTIPLIED BY A FACTOR MSTPF.
C
C            MAXSTP=MSTPF*MAX{ NORM1 , NORM2 }
C
C                 WHERE   MSTPF  USER-CHOSEN FACTOR (DEFAULT: 1000)
C                         NORM1  2-NORM OF SCALED STARTING ESTIMATES
C                         NORM2  2-NORM OF COMPONENT SCALING FACTORS
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION   MAXSTP   ,MSTPF   ,NORM1    ,NORM2
        INTEGER            OUTPUT
        DIMENSION          SCALEX(N),WV1(N)  ,XC(N)
        LOGICAL            OVERFL   ,WRNSUP
        COMMON/NNES_2/WRNSUP
        DATA TEN /10.0D0/
C
        OVERFL=.FALSE.
C
        DO 100 I=1,N
           WV1(I)=SCALEX(I)*XC(I)
100     CONTINUE
        CALL TWONRM(OVERFL,MAXEXP,N,EPSMCH,NORM1,WV1)
        IF(OVERFL) THEN
           MAXSTP=TEN**MAXEXP
           IF(OUTPUT.GT.2.AND.(.NOT.WRNSUP)) THEN
              WRITE(NUNIT,1)
1             FORMAT(T3,'*',T74,'*')
              WRITE(NUNIT,2) NORM1
2             FORMAT(T3,'*',4X,'WARNING: NORM OF SCALED INITIAL ',
     $        'ESTIMATE SET TO ',1PD12.3,T74,'*')
              WRITE(NUNIT,1)
              WRITE(NUNIT,3) MAXSTP
3             FORMAT(T3,'*',7X,'MAXIMUM STEP SIZE, MAXSTP, SET TO ',
     $        1PD12.3,T74,'*')
           END IF
           RETURN
        END IF
        CALL TWONRM(OVERFL,MAXEXP,N,EPSMCH,NORM2,SCALEX)
        IF(OVERFL) THEN
           MAXSTP=TEN**MAXEXP
           IF(OUTPUT.GT.2.AND.(.NOT.WRNSUP)) THEN
              WRITE(NUNIT,1)
              WRITE(NUNIT,4) NORM2
4             FORMAT(T3,'*',4X,'WARNING: NORM OF SCALING FACTORS ',
     $        'SET TO ',1PD12.3,T74,'*')
              WRITE(NUNIT,1)
              WRITE(NUNIT,3) MAXSTP
           END IF
           RETURN
        END IF
        MAXSTP=MSTPF*MAX(NORM1,NORM2)
        RETURN
C
C       LAST CARD OF SUBROUTINE MAXST.
C
        END
