        SUBROUTINE OLHELP(NUNIT,HELP)
C
C       NOV. 4, 1991
C
C       BRIEF DESCRIPTIONS OF INPUT VARIABLES FOR NNES.
C
C       INDIVIDUAL VARIABLES CAN BE ACCESSED BY ASSIGNING THAT
C       VARIABLE'S NAME TO HELP (LEFT-JUSTIFIED PLEASE).
C
C       GROUPS OF VARIABLES CAN BE ACCESSED BY ASSIGNING:
C
C       ALLLOG   ALL LOGICAL VARIABLES
C       ALLINT   ALL INTEGER VARIABLES
C       ALLREA   ALL REAL VARIABLES
C       ALLMAT   ALL MATRICES (INCLUDING VECTORS)
C
C       OR DESCRIPTIONS OF ALL VARIABLES CAN BE ACCESSED BY SETTING
C       HELP TO ALL.
C
C       ERR STAYS TRUE IF AN INCORRECT INPUT WAS GIVEN BY THE USER.
C
        CHARACTER*6 HELP
        LOGICAL     ERR   ,PRALL ,PRALL1 ,PRALL2 ,PRALL3 ,PRALL4
C
C       PRALL  BECOMES TRUE IF ALL VARIABLES ARE TO BE PRINTED.
C       PRALL1 BECOMES TRUE IF ALL LOGICALS  ARE TO BE PRINTED.
C       PRALL2    "      "   "  "  INTEGERS   "   "  "    "   .
C       PRALL3    "      "   "  "  REALS      "   "  "    "   .
C       PRALL4    "      "   "  "  MATRICES   "   "  "    "   .
C
        ERR=.TRUE.
        PRALL =.FALSE.
        PRALL1=.FALSE.
        PRALL2=.FALSE.
        PRALL3=.FALSE.
        PRALL4=.FALSE.
        IF(HELP(1:3).EQ.'ALL'.AND.HELP(4:6).NE.'LOG'
     $                       .AND.HELP(4:6).NE.'INT'
     $                       .AND.HELP(4:6).NE.'REA'
     $                       .AND.HELP(4:6).NE.'MAT') PRALL=.TRUE.
        IF(HELP.EQ.'ALLLOG') PRALL1=.TRUE.
        IF(HELP.EQ.'ALLINT') PRALL2=.TRUE.
        IF(HELP.EQ.'ALLREA') PRALL3=.TRUE.
        IF(HELP.EQ.'ALLMAT') PRALL4=.TRUE.
C
C       LOGICAL VARIABLES.
C
        WRITE(NUNIT,1)
1       FORMAT(T3,72('*'))
        WRITE(NUNIT,2)
2       FORMAT(T3,'*',T74,'*')
        WRITE(NUNIT,3)
3       FORMAT(T3,'*',24X,'ON-LINE HELP FOR NNES',T74,'*')
        WRITE(NUNIT,2)
        WRITE(NUNIT,1)
	  WRITE(NUNIT,2)
        IF(PRALL.OR.PRALL1) THEN
          WRITE(NUNIT,2)
          WRITE(NUNIT,5)
5         FORMAT(T3,'***',2X,'LOGICAL VARIABLES ***',T74,'*')
          WRITE(NUNIT,2)
          WRITE(NUNIT,2)
        END IF
        IF(PRALL.OR.PRALL1.OR.HELP.EQ.'ABSNEW') THEN
          WRITE(NUNIT,6)
6         FORMAT(T3,'**',1X,'ABSNEW **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'DESIGNATES WHETHER ABSOLUTE NEWTON''','S METHOD IS',
     $    ' TO BE USED.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'DEFAULT VALUE: FALSE',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: LINESR, NEWTON',T74,'*')
          WRITE(NUNIT,2)
          ERR=.FALSE.
          IF(HELP.EQ.'ABSNEW') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL1.OR.HELP.EQ.'CAUCHY') THEN
          WRITE(NUNIT,7)
7         FORMAT(T3,'**',1X,'CAUCHY **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'THE CAUCHY POINT IS THE POINT AT THE MINIMUM OF THE',
     $    ' QUADRATIC ',T74,'*',/T3,'*',2X,'MODEL IN THE STEEPEST',
     $    ' DESCENT DIRECTION (THE DISTANCE FROM THE',T74,'*',/T3,
     $    '*',2X,'CURRENT POINT TO THE CAUCHY POINT IS ALWAYS LESS',
     $    ' THAN THE LENGTH',T74,'*',/T3,'*',2X,'OF THE NEWTON STEP).',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'CAUCHY:  TRUE => ',
     $    ' INITIAL TRUST',' REGION IS DISTANCE TO CAUCHY POINT',T74,
     $    '*',/T3,'*',11X,'FALSE => INITIAL TRUST REGION IS LENGTH',
     $    ' OF NEWTON STEP',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'DEFAULT VALUE: FALSE (MORE AMBITIOUS; TRUE IS CONSERVATIVE)',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'NOT USED IN LINE SEARCH',
     $    ' METHODS',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: LINESR,DELTA',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'CAUCHY') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL1.OR.HELP.EQ.'DEUFLH') THEN
          WRITE(NUNIT,8)
8         FORMAT(T3,'**',1X,'DEUFLH **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'INITIALIZATION OF THE RELAXATION FACTOR FOR LINE',
     $    ' SEARCHES USING',T74,'*',/T3,'*',2X,'A MODIFICATION OF',
     $    ' THE DEUFLHARD METHOD. THE INITIAL LAMBDA IN ANY',T74,'*',
     $    /T3,'*',2X,'LINE SEARCH IS SET TO 1.0 USUALLY, UNLESS',
     $    ' IT IS FOUND INTERNALLY,',T74,'*',/T3,'*',2X,'USING',
     $    ' DEUFLHARD''','S METHOD, THAT A SMALL VALUE OF LAMBDA IS',
     $    ' MORE',T74,'*',/T3,'*',2X,'LIKELY WHEREUPON LAMBDA IS',
     $    ' INITIALIZED TO 0.1.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'DEUFLH:  TRUE =>  DEUFLHARD INITIALIZATION USED',T74,'*',
     $    /T3,'*',11X,'FALSE => INITIAL RELAXATION FACTOR IS',
     $    ' ALWAYS LAM0',T74,'*',/T3,'*',19X,' (LAM0 IS USUALLY 1.0)',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: TRUE',T74,
     $    '*',/T3,'*',T74,'*',/T3,'*',2X,'NOT USED IN TRUST REGION ',
     $    'METHODS',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'DEUFLH') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL1.OR.HELP(1:5).EQ.'GEOMS') THEN
          WRITE(NUNIT,9)
9         FORMAT(T3,'**',1X,'GEOMS **',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'TWO CHOICES ARE AVAILABLE WHEN REDUCING THE RELAXATION',
     $    ' FACTOR IN',T74,'*',/T3,'*',2X,'LINE SEARCHES OR THE TRUST',
     $    ' REGION SIZE IN TRUST REGION METHODS',T74,'*',/T3,'*'
     $    ,T74,'*',/T3,'*',2X,'GEOMS:   TRUE =>  GEOMETRIC REDUCTION;',
     $    ' FACTOR SIGMA FOR L.S.',T74,'*',/T3,'*',48X,'DELFAC FOR ',
     $    'T.R.',T74,'*',/T3,'*',20X,'I.E.,',' LAMBDA(NEW)=0.5*LAMBDA',
     $    '(OLD) FOR LINE',T74,'*',/T3,'*',20X,'SEARCHES AND DELTA',
     $    '(NEW)=0.5*DELTA(OLD) FOR',T74,'*',/T3,'*',20X,'TRUST REGION',
     $    ' METHODS.',T74,'*',/T3,'*',11X,'FALSE => SAFEGUARDED',
     $    ' POLYNOMIAL INTERPOLATION',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'DEFAULT VALUE: TRUE',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCES: DELFAC, SIGMA',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:5).EQ.'GEOMS') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL1.OR.HELP.EQ.'LINESR') THEN
          WRITE(NUNIT,10)
10        FORMAT(T3,'**',1X,'LINESR **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'DISTINGUISHES BETWEEN MAJOR SOLUTION METHODS.',T74,
     $    '*',/T3,'*',T74,'*',/T3,'*',2X,'LINESR:  TRUE =>  ',
     $    'LINE SEARCH METHOD',T74,'*',/T3,'*',11X,'FALSE => TRUST',
     $    ' REGION METHOD',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'DEFAULT VALUE: TRUE',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'LINESR') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL1.OR.HELP.EQ.'MATSUP') THEN
          WRITE(NUNIT,11)
11        FORMAT(T3,'**',1X,'MATSUP **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'SUPPRESSES MATRIX PRINTING IN DETAILED OUTPUT.',T74,
     $    '*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: FALSE',T74,
     $    '*',/T3,'*',T74,'*',/T3,'*',2X,'CROSS-REFERENCE: OUTPUT',
     $    T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'MATSUP') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL1.OR.HELP.EQ.'OVERCH') THEN
          WRITE(NUNIT,12)
12        FORMAT(T3,'**',1X,'OVERCH **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'CHECKS FOR POTENTIAL OVERFLOWS AT KEY',
     $    ' LOCATIONS; INSERTS',T74,'*',/T3,'*',2X,'(+OR-)10**MAXEXP',
     $    ' AS AN APPROXIMATION IF AN OVERFLOW IS IMMINENT.',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'OVERCH:  TRUE => OVERFLOW',
     $    ' CHECKING',T74,'*',/T3,'*',11X,'FALSE => NORMAL EXECUTION',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: FALSE ',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'CROSS-REFERENCE: ',
     $    'MAXEXP',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'OVERCH'.OR.HELP.EQ.'ALLLOG') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL1.OR.HELP.EQ.'WRNSUP') THEN
          WRITE(NUNIT,13)
13        FORMAT(T3,'**',1X,'WRNSUP **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'SUPPRESSES PRINTING WARNINGS; USED WHEN KNOWN',
     $    ' WARNINGS',T74,'*',/T3,'*',2X,'WILL CLUTTER OUTPUT.',T74,
     $    '*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: FALSE',T74,
     $    '*',/T3,'*',T74,'*',/T3,'*',2X,'CROSS-REFERENCE: OUTPUT',
     $    T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'WRNSUP') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2) THEN
          WRITE(NUNIT,2)
          WRITE(NUNIT,14)
14        FORMAT(T3,'***',2X,'INTEGER VARIABLES ***',T74,'*')
          WRITE(NUNIT,2)
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'ACPTCR') THEN
          WRITE(NUNIT,2)
          WRITE(NUNIT,15)
15        FORMAT(T3,'**',1X,'ACPTCR **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'A STEP CAN BE ACCEPTED BY THE STANDARD OBJECTIVE',
     $    ' FUNCTION, WHICH',T74,'*',/T3,'*',2X,'IS 1/2 {SUM OF',
     $    ' SQUARES OF RESIDUALS}, ALONE OR BY DEUFLHARD''','S ',
     $    T74,'*',/T3,'*',2X,'"NATURAL" OBJECTIVE FUNCTION AS WELL.',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'ACPTCR:  1  => USE ONLY',
     $    ' STANDARD OBJECTIVE FUNCTION',T74,'*',/T3,'*',11X,
     $    '12 => ACCEPT',' STEP BASED ON EITHER CRITERION',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 12 ',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'ACPTCR') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'ITSCLF') THEN
          WRITE(NUNIT,16)
16        FORMAT(T3,'**',1X,'ITSCLF **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'ITERATION AT WHICH ADAPTIVE SCALING OF THE',
     $    ' FUNCTIONS BEGINS.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'ITSCLF:  0  => NO ADAPTIVE FUNCTION SCALING',T74,'*',
     $    /T3,'*',11X,'K  => ADAPTIVE FUNCTION SCALING BEGINS AT',
     $    ' ITERATION K',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'DEFAULT VALUE: 0',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: SCALEF',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'ITSCLF') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'ITSCLX') THEN
          WRITE(NUNIT,17)
17        FORMAT(T3,'**',1X,'ITSCLX **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'ITERATION AT WHICH ADAPTIVE SCALING OF THE',
     $    ' VARIABLES BEGINS.',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'ITSCLX:  0  => NO ADAPTIVE VARIABLE SCALING',T74,
     $    '*',/T3,'*',11X,'K  => ADAPTIVE VARIABLE SCALING BEGINS',
     $    ' AT ITERATION K',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'DEFAULT VALUE: 0',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $   'CROSS-REFERENCE: SCALEX',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'ITSCLX') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'JACTYP') THEN
          WRITE(NUNIT,18)
18        FORMAT(T3,'**',1X,'JACTYP **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'JACTYP DETERMINES HOW THE JACOBIAN IS TO BE',
     $    ' EVALUATED EXPLICITLY',T74,'*',/T3,'*',2X,'(VERSUS BEING',
     $    ' UPDATED VIA A QUASI-NEWTON METHOD). LOWER AND UPPER',T74,
     $    '*',/T3,'*',2X,'BOUNDS ARE CHECKED TO PREVENT VIOLATIONS.',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'JACTYP:  0  => ',
     $    'ANALYTICAL JACOBIAN (DECLARE IN EXTERNAL STATEMENT)',
     $    T74,'*',/T3,'*',11X,'1  => FORWARD DIFFERENCES',
     $    T74,'*',/T3,'*',11X,'2  => BACKWARD DIFFERENCES',
     $    T74,'*',/T3,'*',11X,'3  => CENTRAL DIFFERENCES',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 1 ',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'CROSS-REFERENCE: ',
     $    'JUPDM',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'JACTYP') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP(1:5).EQ.'JUPDM') THEN
          WRITE(NUNIT,19)
19        FORMAT(T3,'**',1X,'JUPDM **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'JUPDM DETERMINES WHETHER THE JACOBIAN IS TO BE',
     $    ' EVALUATED',T74,'*',/T3,'*',2X,'EXPLICITLY OR TO BE',
     $    ' UPDATED VIA A QUASI-NEWTON METHOD.',T74,'*',/T3,'*',2X,
     $    T74,'*',/T3,'*',2X,'JUPDM:   0  => JACOBIAN EVALUATED',
     $    ' EXPLICITLY (SEE JACTYP FOR',T74,'*',/T3,'*',17X,
     $    'DIFFERENCING OPTIONS)',
     $    T74,'*',/T3,'*',11X,'1  => BROYDEN UPDATE',
     $    T74,'*',/T3,'*',11X,'2  => LEE AND LEE UPDATE',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 0 ',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'CROSS-REFERENCE: ',
     $    'JACTYP',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:5).EQ.'JUPDM') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'MAXEXP') THEN
          WRITE(NUNIT,20)
20        FORMAT(T3,'**',1X,'MAXEXP **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'MAXIMUM EXPONENT ALLOWED, BASE 10, DETERMINED IN',
     $    ' SUBROUTINE SETUP',T74,'*',/T3,'*',2X,'BY SUBROUTINE',
     $    ' MACHAR, E.G., 38 FOR THE VAX, 308 FOR IBM PC''','S.',T74,
     $    '*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE:',
     $    ' DETERMINED INTERNALLY',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'CROSS-REFERENCE: OVERCH',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'MAXEXP') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP(1:5).EQ.'MAXIT') THEN
          WRITE(NUNIT,21)
21        FORMAT(T3,'**',1X,'MAXIT **',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'MAXIMUM NUMBER OF ITERATIONS ALLOWED',T74,'*',/T3,'*',
     $    T74,'*',/T3,'*',2X,'DEFAULT VALUE: 100',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:5).EQ.'MAXIT') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP(1:5).EQ.'MAXNS') THEN
          WRITE(NUNIT,22)
22        FORMAT(T3,'**',1X,'MAXNS **',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'MAXIMUM NUMBER OF LINE SEARCH STEPS OR TRUST REGION',
     $    ' REDUCTIONS',T74,'*',/T3,'*',2X,'ALLOWED WHEN THE JACOBIAN',
     $    ' HAS BEEN CALCULATED EXPLICITLY, I.E.,',T74,'*',/T3,'*',2X,
     $    'BY FINITE DIFFERENCES OR USING A USER-SUPPLIED JACOBIAN.',
     $    ' THIS',T74,'*',/T3,'*',2X,'IS USUALLY GREATER THAN MAXQNS,',
     $    ' THE NUMBER OF LINE SEARCH STEPS',T74,'*',/T3,'*',2X,
     $    'OR TRUST REGION REDUCTIONS ALLOWED AFTER THE JACOBIAN',
     $    ' HAS BEEN',T74,'*',/T3,'*',2X,'UPDATED USING A QUASI-NEWTON',
     $    ' METHOD.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT',
     $    ' VALUE: 50',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: MAXQNS',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:5).EQ.'MAXNS') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'MAXQNS') THEN
          WRITE(NUNIT,23)
23        FORMAT(T3,'**',1X,'MAXQNS **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'MAXIMUM NUMBER OF LINE SEARCH STEPS OR TRUST REGION',
     $    ' REDUCTIONS',T74,'*',/T3,'*',2X,'ALLOWED WHEN THE JACOBIAN',
     $    ' HAS BEEN UPDATED BY A QUASI-NEWTON',T74,'*',/T3,
     $    '*',2X,'METHOD; THIS IS DESIGNED TO PREVENT EXCESSIVE LINE',
     $    ' SEARCH STEPS',T74,'*',/T3,'*',2X,'IN A POOR SEARCH',
     $    ' DIRECTION.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'DEFAULT VALUE: 10',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: MAXNS',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'MAXQNS') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP(1:4).EQ.'MGLL') THEN
          WRITE(NUNIT,24)
24        FORMAT(T3,'**',1X,'MGLL **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'NUMBER OF PREVIOUS MERIT FUNCTION(S) VALUES USED',
     $    ' FOR THE',T74,'*',/T3,'*',2X,'NONMONOTONIC STEP',
     $    ' ACCEPTANCE CRITERIA; THE SUM OF SQUARES',T74,'*',/T3,'*',
     $    2X,'AND POSSIBLY DEUFLHARD''','S CRITERION IS(ARE)',
     $    ' COMPARED TO THE',T74,'*',/T3,'*',2X,'GREATEST OF THE',
     $    ' MOST RECENT "MGLL" VALUES STORED IN THE FTRACK',T74,
     $    '*',/T3,'*',2X,'AND STRACK VECTORS RESPECTIVELY.',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'E.G. LINE SEARCHES, THE ',
     $    'ACCEPTANCE CRITERION FOR A FUNCTION, F, IS',T74,'*',/T3,
     $    '*',T74,'*',/T3,'*',
     $    3X,'F(NEW) <= FMAX+LAMBDA*ALPHA*DELF^S   WHERE',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',
     $    3X,'F      IS THE OBJECTIVE FUNCTION',T74,'*',/T3,'*',
     $    3X,'LAMBDA IS THE RELAXATION FACTOR',T74,'*',/T3,'*',
     $    3X,'ALPHA  IS THE ARMIJO CONSTANT',T74,'*',/T3,'*',
     $    3X,'DELF   IS THE GRADIENT OF F',T74,'*',/T3,'*',
     $    3X,'S      IS THE PROPOSED STEP',T74,'*',/T3,'*',
     $    3X,'FMAX   IS GIVEN BY',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    3X,'MAX(F(K-J)), 0 <= J <= M(K)   WHERE',T74,'*',/T3,'*',
     $    T74,'*',/T3,'*',3X,'M(K) = MIN[M(K-1)+1,MGLL]',T74,'*',/T3,
     $    '*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: GIVEN BY USER',
     $    ' AS A PARAMETER, 10 IS TYPICAL',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'CROSS-REFERENCE: NARMIJ,ALPHA',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:4).EQ.'MGLL') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'MINQNS') THEN
          WRITE(NUNIT,25)
25        FORMAT(T3,'**',1X,'MINQNS **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'MINIMUM NUMBER OF QUASI-NEWTON STEPS WHICH MUST',
     $    ' BE TAKEN',T74,'*',/T3,'*',2X,'BETWEEN EXPLICIT JACOBIAN',
     $    ' EVALUATIONS.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'DEFAULT VALUE: 6',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: JACTYP,JUPDM,RATIOF',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'MINQNS') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'NARMIJ') THEN
          WRITE(NUNIT,26)
26        FORMAT(T3,'**',1X,'NARMIJ **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'WHEN THE JACOBIAN IS EVALUATED EXPLICITLY AT',
     $    ' EACH ITERATION, IT',T74,'*',/T3,'*',2X,'IS THE NUMBER OF',
     $    ' STEPS WHICH MUST SATISFY THE ARMIJO CRITERION AT',T74,'*',
     $    /T3,'*',2X,'THE START OF THE PROBLEM, I.E., STRICT DESCENT',
     $    ' STEPS AT THE ',T74,'*',/T3,'*',2X,'START. IN QUASI-NEWTON',
     $    ' METHODS IT IS THE NUMBER OF STEPS WHICH',T74,'*',/T3,'*',
     $    2X,'MUST SATISFY THE ARMIJO CRITERION AFTER EACH EXPLICIT',
     $    ' JACOBIAN',T74,'*',/T3,'*',2X,'EVALUATION. THE ARMIJO',
     $    ' CRITERION TESTS WHETHER',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    3X,'F(NEW) <= F(OLD)+LAMBDA*ALPHA*DELF^S   WHERE',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',
     $    3X,'F      IS THE OBJECTIVE FUNCTION',T74,'*',/T3,'*',
     $    3X,'LAMBDA IS THE RELAXATION FACTOR',T74,'*',/T3,'*',
     $    3X,'ALPHA  IS THE ARMIJO CONSTANT',T74,'*',/T3,'*',
     $    3X,'DELF   IS THE GRADIENT OF F',T74,'*',/T3,'*',
     $    3X,'S      IS THE PROPOSED STEP',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'DEFAULT VALUE: 1',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'CROSS-REFERENCE: MGLL,ALPHA',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'NARMIJ') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'NFETOT') THEN
          WRITE(NUNIT,27)
27        FORMAT(T3,'**',1X,'NFETOT **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'TOTAL NUMBER OF FUNCTION EVALUATIONS INCLUDING',
     $    ' THOSE REQUIRED',T74,'*',/T3,'*',2X,'FOR THE FINITE-',
     $    'DIFFERENCE CALCULATION OF JACOBIANS.',T74,'*',/T3,'*',
     $    T74,'*',/T3,'*',2X,'DEFAULT VALUE: N/A (OUTPUT)',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'NFETOT') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'NINITN') THEN
          WRITE(NUNIT,28)
28        FORMAT(T3,'**',1X,'NINITN **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'MAY BE USED TO DELAY ONSET OF LINE SEARCHES OR',
     $    ' TRUST REGION STEPS.',T74,'*',/T3,'*',2X,'IT IS THE NUMBER',
     $    ' OF INITIAL NEWTON STEPS BEFORE LINE SEARCHES OR',T74,'*',
     $    /T3,'*',2X,'TRUST REGION STEPS BEGIN.',T74,'*',/T3,'*',T74,
     $    '*',/T3,'*',2X,'DEFAULT VALUE: 0',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'NINITN') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'NJACCH') THEN
          WRITE(NUNIT,29)
29        FORMAT(T3,'**',1X,'NJACCH **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'THE NUMBER TIMES AN ANALYTICAL JACOBIAN IS CHECKED',
     $    ' USING FINITE',T74,'*',/T3,'*',2X,'DIFFERENCES AT THE',
     $    ' START OF THE PROBLEM. THE TOLERANCE USED FOR',T74,'*',
     $    /T3,'*',2X,'COMPARISON IS GIVEN BY FDTOLJ.',T74,'*',/T3,
     $    '*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 0',T74,'*',/T3,'*',
     $    T74,'*',/T3,'*',2X,'CROSS-REFERENCE: FDTOLJ',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'NJACCH') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP(1:5).EQ.'NUNIT') THEN
          WRITE(NUNIT,30)
30        FORMAT(T3,'**',1X,'NUNIT **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'NUMBER OF THE LOGICAL UNIT FOR OUTPUT.',T74,'*',/T3,
     $    '*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: GIVEN BY USER',
     $    T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:5).EQ.'NUNIT') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'OUTPUT') THEN
          WRITE(NUNIT,31)
31        FORMAT(T3,'**',1X,'OUTPUT **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'OUTPUT DETERMINES THE DETAIL OF THE OUTPUT.',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'OUTPUT:  0  => NO OUTPUT',
     $    T74,'*',/T3,'*',11X,'1  => ANSWER ONLY',
     $    T74,'*',/T3,'*',11X,'2  => ECHO INPUT PLUS ANSWER',
     $    T74,'*',/T3,'*',11X,'3  => SUMMARY OF EACH ITERATION',
     $    T74,'*',/T3,'*',11X,'4  => DETAILED DESCRIPTION OF EACH',
     $    ' ITERATION',
     $    T74,'*',/T3,'*',11X,'5  => VERY DETAILED DESCRIPTION OF',
     $    ' EACH ITERATION',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 2',
     $    T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'OUTPUT') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'QNUPDM') THEN
          WRITE(NUNIT,32)
32        FORMAT(T3,'**',1X,'QNUPDM **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'QNUPDM DETERMINES HOW THE QUASI-NEWTON',
     $    ' UPDATE IS DONE.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'QNUPDM:  0  => UPDATE UNFACTORED JACOBIAN',T74,'*',/T3,
     $    '*',11X, '1  => UPDATE QR DECOMPOSITION OF JACOBIAN',T74,
     $    '*',/T3,'*',T74,'*',/T3,'*',2X,'QNUPDM=1 IS FASTER. USE ',
     $    'THIS UNLESS YOU WANT TO SEE THE',T74,'*',/T3,'*',2X,
     $    'JACOBIAN AT EACH ITERATION.',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'DEFAULT VALUE: 1',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'QNUPDM') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'STOPCR') THEN
          WRITE(NUNIT,33)
33        FORMAT(T3,'**',1X,'STOPCR **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'STOPCR DETERMINES THE STOPPING CRITERIA USED.',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'STOPCR:  1  => STOP',
     $    ' BASED ON STEP SIZE ONLY',T74,'*',/T3,'*',11X,
     $    '2  => STOP BASED ON OBJECTIVE FUNCTION VALUE ONLY',T74,'*',
     $    /T3,'*',11X,'12 => STOP BASED ON EITHER STEP SIZE OR',
     $    ' FUNCTION VALUE',T74,'*',/T3,'*',11X,'3  => STOP BASED',
     $    ' ON BOTH BEING SATISFIED',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'SEE FTOL, NSTTOL AND STPTOL FOR DETAILS OF THE CRITERIA.'
     $    ,' THERE ARE',T74,'*',/T3,'*',2X,'TWO STEP SIZE CRITERIA:',
     $    ' THE ONE BASED ON THE FULL NEWTON STEP IS',T74,'*',/T3,
     $    '*',2X,'GOVERNED BY NSTTOL, AND THE OTHER BASED ON THE',
     $    ' STEP SIZE AFTER',T74,'*',/T3,'*',2X,'THE LINE SEARCH',
     $    ' OR TRUST REGION REDUCTION IS GOVERNED BY STPTOL.',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 12',T74,'*',/T3,
     $    '*',T74,'*',/T3,'*',2X,'CROSS-REFERENCE: TRMCOD,FTOL,',
     $    'NSTTOL,STPTOL',T74,'*',/T3,'*',2X,T74,'*')
	    ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'STOPCR') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'SUPPRS') THEN
          WRITE(NUNIT,34)
34        FORMAT(T3,'**',1X,'SUPPRS **',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'SUPPRESS DETAILED OUTPUT FOR "SUPPRS" ITERATIONS;',
     $    ' USED PRIMARILY',T74,'*',/T3,'*',2X,'TO SEE DETAILED',
     $    ' OUTPUT BEFORE A FAILURE IN A LARGE PROBLEM.',T74,'*',/T3,
     $    '*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 0',T74,'*',/T3,'*',
     $    T74,'*',/T3,'*',2X,'CROSS-REFERENCE: OUTPUT',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'SUPPRS') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'TRMCOD') THEN
          WRITE(NUNIT,35)
35        FORMAT(T3,'**',1X,'TRMCOD **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'TRMCOD TELLS WHICH STOPPING CRITERIA WERE MET.',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'TRMCOD:  1  => STOP',
     $    ' BASED ON STEP SIZE ONLY',T74,'*',/T3,'*',11X,
     $    '2  => STOP BASED ON OBJECTIVE FUNCTION VALUE ONLY',T74,'*',
     $    /T3,'*',11X,'12 => STOP BASED ON EITHER STEP SIZE OR',
     $    ' FUNCTION VALUE',T74,'*',/T3,'*',11X,'3  => STOP BASED',
     $    ' ON BOTH BEING SATISFIED',T74,'*',/T3,'*',T74,'*'/T3,'*',
     $    2X,'SEE FTOL, NSTTOL AND STPTOL FOR DETAILS OF THE CRITERIA.'
     $    ,' THERE ARE',T74,'*',/T3,'*',2X,'TWO STEP SIZE CRITERIA:',
     $    ' THE ONE BASED ON THE FULL NEWTON STEP IS',T74,'*',/T3,
     $    '*',2X,'GOVERNED BY NSTTOL, AND THE OTHER BASED ON THE',
     $    ' STEP SIZE AFTER',T74,'*',/T3,'*',2X,'THE LINE SEARCH',
     $    ' OR TRUST REGION REDUCTION IS GOVERNED BY STPTOL.',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: N/A (OUTPUT)',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'CROSS-REFERENCE: ',
     $    'STOPCR,FTOL,NSTTOL,STPTOL',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'TRMCOD') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL2.OR.HELP.EQ.'TRUPDM') THEN
          WRITE(NUNIT,36)
36        FORMAT(T3,'**',1X,'TRUPDM **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'TRUPDM DETERMINES THE TRUST REGION UPDATING',
     $    ' METHOD.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'TRUPDM:  0  => POWELL''','S SCHEME',T74,'*',/T3,'*',11X,
     $    '1  => DENNIS AND SCHNABEL''','S SCHEME',T74,'*',/T3,'*',
     $    T74,'*',/T3,'*',2X,'DEFAULT VALUE: 0',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'TRUPDM'.OR.HELP.EQ.'ALLINT') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3) THEN
          WRITE(NUNIT,2)
          WRITE(NUNIT,37)
37        FORMAT(T3,'***',2X,'REAL VARIABLES ***',T74,'*')
          WRITE(NUNIT,2)
          WRITE(NUNIT,2)
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP(1:5).EQ.'ALPHA') THEN
          WRITE(NUNIT,38)
38        FORMAT(T3,'**',1X,'ALPHA **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'ARMIJO CONSTANT. FOR MONOTONIC LINE SEARCHES,',
     $    ' A STEP IS ACCEPTED IF',T74,'*',/T3,'*',T74,'*',/T3,'*',3X,
     $    'F(NEW) <= F(OLD)+LAMBDA*ALPHA*(DIRECTIONAL DERIVATIVE)',
     $    '   WHERE',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'F',6X,'IS THE'
     $    ,' OBJECTIVE FUNCTION',T74,'*',/T3,'*',2X,'LAMBDA IS THE',
     $    ' RELAXATION FACTOR IN THE LINE SEARCH',T74,'*',/T3,
     $    '*',2X,'THE DERIVATIVE IS IN THE LINE SEARCH DIRECTION.'
     $    ,T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'SIMILARLY,',
     $    ' FOR TRUST REGION METHODS, THE CRITERION IS',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',3X,'F(NEW) <= F(OLD)+ALPHA*',
     $    '(DIRECTIONAL DERIVATIVE)   WHERE',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'THE DERIVATIVE IS IN THE TRUST REGION STEP',
     $    ' DIRECTION.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'THE',
     $    ' CRITERION IS DIFFERENT FOR NONMONOTONIC SEARCHES, SEE',
     $    ' MGLL.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT',
     $    ' VALUE: 1.0D-04',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: MGLL,NARMIJ',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:5).EQ.'ALPHA') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP.EQ.'CONFAC') THEN
          WRITE(NUNIT,39)
39        FORMAT(T3,'**',1X,'CONFAC **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'CONSTRAINT FACTOR WHICH GIVES THE FRACTION OF',
     $    ' THE DISTANCE',T74,'*',/T3,'*',2X,'TO THE FIRST VIOLATED',
     $    ' CONSTRAINT AT WHICH A LINE SEARCH WOULD',T74,'*',/T3,
     $    '*',2X,'START OR A TRUST REGION LIMIT SET.',T74,'*',/T3,'*',
     $    T74,'*',/T3,'*',2X,'DEFAULT VALUE: 0.95D0',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'CONFAC') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP(1:5).EQ.'DELTA') THEN
          WRITE(NUNIT,40)
40        FORMAT(T3,'**',1X,'DELTA **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'DELTA IS THE TRUST REGION RADIUS. IF IT IS',
     $    ' NEGATIVE ON',T74,'*',/T3,'*',2X,'INPUT, THE INITIAL',
     $    ' TRUST REGION SIZE IS CALCULATED INTERNALLY;',T74,'*',/T3,
     $    '*',2X,'SEE CAUCHY. A POSITIVE ENTRY SETS THE INITIAL',
     $    ' TRUST REGION.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'DEFAULT VALUE: -1.0D0',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: CAUCHY,LINESR',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:5).EQ.'DELTA') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP.EQ.'DELFAC') THEN
          WRITE(NUNIT,41)
41        FORMAT(T3,'**',1X,'DELFAC **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'DELFAC IS THE FACTOR BY WHICH THE TRUST REGION',
     $    ' RADIUS IS CHANGED,',T74,'*',/T3,'*',2X,'BOTH WHEN',
     $    ' INCREASED AND WHEN DECREASED, IF DELTA IS NOT BEING',T74,
     $    '*',/T3,'*',2X,'BEING INCREASED TO THE LENGTH OF THE NEWTON',
     $    ' STEP.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE:',
     $    ' 2.0D0',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: TRUPDM,DELTA',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'DELFAC') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP.EQ.'EPSMCH') THEN
          WRITE(NUNIT,42)
42        FORMAT(T3,'**',1X,'EPSMCH **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'MACHINE PRECISION; AN ESTIMATE OF THE',
     $    ' SMALLEST FLOATING POINT',T74,'*',/T3,'*',2X,'NUMBER',
     $    ' SUCH THAT 1.0+X > 1.0.',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'DEFAULT VALUE: CALCULATED INTERNALLY',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'EPSMCH') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP.EQ.'ETAFAC') THEN
          WRITE(NUNIT,43)
43        FORMAT(T3,'**',1X,'ETAFAC **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'FACTOR USED IN DETERMINING THE SHAPE',
     $    ' OF THE DOUBLE DOGLEG STEP',T74,'*',/T3,'*',2X,'IN TRUST',
     $    ' REGION METHODS; ETAFAC=1 CORRESPONDS TO SINGLE DOGLEG.',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 0.2D0',
     $    T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'ETAFAC') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP.EQ.'FCNNEW') THEN
          WRITE(NUNIT,44)
44        FORMAT(T3,'**',1X,'FCNNEW **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'ON RETURN, FCNNEW HOLDS THE FINAL VALUE',
     $    ' OF THE SUM-OF-SQUARES',T74,'*',/T3,'*',2X,'OBJECTIVE',
     $    ' FUNCTION.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'DEFAULT VALUE: N/A (OUTPUT)',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'FCNNEW') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP.EQ.'FDTOLJ') THEN
          WRITE(NUNIT,45)
45        FORMAT(T3,'**',1X,'FDTOLJ **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'TOLERANCE FOR A FINITE-DIFFERENCE CHECK OF',
     $    ' AN ANALYTICAL JACOBIAN.',T74,'*',/T3,'*',2X,'IF JACFD(I)',
     $    ' IS THE FINITE-DIFFERENCE APPROXIMATION AND JACAN(I)',
     $    T74,'*',/T3,'*',2X,'IS THE ANALYTICAL DERIVATIVE, WHEN',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',3X,
     $    'ABS(JACFD(I)-JACAN(I))/MAX(ABS(JACFD(I)),1) >= FDTOLJ',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'THEN A FAILURE IS',
     $    ' DECLARED.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT',
     $    ' VALUE: 1.0D-06',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: NJACCH',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'FDTOLJ') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP(1:4).EQ.'FTOL') THEN
          WRITE(NUNIT,46)
46        FORMAT(T3,'**',1X,'FTOL **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'STOPPING TOLERANCE FOR MAX-NORM OF SCALED',
     $    ' FUNCTION VECTOR; IF',T74,'*',/T3,'*',T74,'*',/T3,'*',3X,
     $    'MAX(SCALEF(I)*ABS(FVEC(I))) I=1,...,N <  FTOL ,STOP.',T74,
     $    '*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: ',
     $    'EPSMCH**(1/3)',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: STOPCR,TRMCOD',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:4).EQ.'FTOL') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP(1:4).EQ.'LAM0') THEN
          WRITE(NUNIT,47)
47        FORMAT(T3,'**',1X,'LAM0 **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'USED TO SET THE INITIAL RELAXATION FACTOR',
     $    ' IN LINE SEARCHES',T74,'*',/T3,'*',2X,'TO A VALUE LESS',
     $    ' THAN 1.0 FOR EXTREMELY NONLINEAR PROBLEMS',T74,'*',/T3,
     $    '*',2X,'THIS OVERRIDES DEUFLHARD INITIALIZATION.',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 1.0D0',T74,'*'
     $    ,/T3,'*',T74,'*',/T3,'*',2X,'CROSS-REFERENCE: DEUFLH',
     $    T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:4).EQ.'LAM0') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP(1:5).EQ.'MSTPF') THEN
          WRITE(NUNIT,48)
48        FORMAT(T3,'**',1X,'MSTPF **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'FACTOR USED TO SET THE MAXIMUM STEP SIZE',
     $    ' ALLOWED. USUALLY THE',T74,'*',/T3,'*',2X,'MAXIMUM STEP',
     $    ' SIZE IS SET BY NNES IS MUCH TOO LARGE TO HAVE ANY',
     $    T74,'*',/T3,'*',2X,'EFFECT, BUT IN SOME CASES THE USER MAY',
     $    ' NEED TO RESTRICT POSSIBLY',T74,'*',/T3,'*',2X,'FATAL',
     $    ' STEPS. THE MAXIMUM STEP IS SET BY:',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'MAXSTP=MSTPF*MAX(NORM1,NORM2) WHERE',T74,'*',/T3,
     $    '*',2X,T74,'*',/T3,'*',2X,' NORM1=2-NORM OF SCALED',
     $    ' STARTING ESTIMATES',T74,'*',/T3,'*',2X,' NORM2=2-NORM OF',
     $    ' COMPONENT SCALING FACTORS',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'DEFAULT VALUE: 1.0D3',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:5).EQ.'MSTPF') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP.EQ.'NSTTOL') THEN
          WRITE(NUNIT,49)
49        FORMAT(T3,'**',1X,'NSTTOL **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'STOPPING TOLERANCE FOR FULL NEWTON STEP; STOP',
     $    ' IF, FOR ALL I,',T74,'*',/T3,'*',T74,
     $    '*',/T3,'*',3X,'MAX(ABS[SN(I)]/MAX(ABS[X(I)],1/SCALEX(I))',
     $    ' < NSTTOL*(1+NORM(DX(I)))',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    3X,'SN(I)     IS THE I(TH) COMPONENT OF THE NEWTON STEP',T74,
     $    '*',/T3,'*',3X,'SCALEX(I) IS THE COMPONENT SCALING FACTOR',
     $    T74,'*',/T3,'*',3X,'DX(I)     IS SCALEX(I)*X(I)',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: EPSMCH**(2/3)',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'CROSS-REFERENCE: ',
     $    'STOPCR,TRMCOD,SCALEX',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'NSTTOL') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP(1:5).EQ.'OMEGA') THEN
          WRITE(NUNIT,50)
50        FORMAT(T3,'**',1X,'OMEGA **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'FACTOR IN THE LEE AND LEE QUASI-NEWTON',
     $    ' UPDATES.',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'DEFAULT VALUE: 1.0D-01',T74,'*',/T3,'*',T74,'*',/T3,
     $    '*',2X,'CROSS-REFERENCE: JUPDM',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:5).EQ.'OMEGA') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP.EQ.'RATIOF') THEN
          WRITE(NUNIT,51)
51        FORMAT(T3,'**',1X,'RATIOF **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'FACTOR USED IN QUASI-NEWTON METHODS TO DECIDE',
     $    ' WHETHER AN',T74,'*',/T3,'*',2X,'EXPLICIT JACOBIAN UPDATE',
     $    ' SHOULD BE DONE. IF',T74,'*',/T3,'*',T74,'*',/T3,'*',3X,
     $    'F(NEW) > RATIOF*F(OLD)   THEN:  NFAIL=NFAIL+1',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'ELSE IF',T74,'*',/T3,'*',T74,
     $    '*',/T3,'*',3X,'F(NEW) < 0.01*F(OLD)   THEN: NFAIL=NFAIL-1',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'IF NFAIL > MINQNS, NNES',
     $    ' RESTARTS AT THE BEST POINT FOUND SO FAR',T74,'*',/T3,'*',
     $    2X,'AS IF THAT POINT WERE A NEW INITIAL ESTIMATE.',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 7.0D-01',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'CROSS-REFERENCE: MINQNS',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'RATIOF') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP(1:5).EQ.'SIGMA') THEN
          WRITE(NUNIT,52)
52        FORMAT(T3,'**',1X,'SIGMA **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'FACTOR USED IN GEOMETRIC STEP REDUCTIONS TO',
     $    ' DECREASE THE',T74,'*',/T3,'*',2X,'RELAXATION',
     $    ' FACTOR IN LINE SEARCHES:'
     $    ,T74,'*',/T3,'*',T74,'*',/T3,'*',3X,'LAMBDA(NEW)=',
     $    'SIGMA*LAMBDA(OLD)',T74,'*',/T3,'*',T74,
     $    '*',/T3,'*',2X,'DEFAULT VALUE: 5.0D-01',T74,'*',/T3,'*',T74,
     $    '*',/T3,'*',2X,'CROSS-REFERENCE: GEOMS',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:5).EQ.'SIGMA') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL3.OR.HELP.EQ.'STPTOL') THEN
          WRITE(NUNIT,53)
53        FORMAT(T3,'**',1X,'STPTOL **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'STOPPING TOLERANCE FOR STEP AFTER REDUCTION;',
     $    ' STOP IF, FOR ALL I,',T74,'*',/T3,'*',T74,
     $    '*',/T3,'*',3X,'MAX(ABS[S(I)]/MAX(ABS[X(I)],1/SCALEX(I))',
     $    ' < STPTOL',T74,'*',/T3,'*',T74,'*',/T3,'*',3X,'S(I)     IS',
     $    ' THE I(TH) COMPONENT OF THE REDUCED STEP',T74,
     $    '*',/T3,'*',3X,'SCALEX(I) IS THE COMPONENT SCALING FACTOR',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: ',
     $    'EPSMCH**(2/3)',T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: STOPCR,TRMCOD,SCALEX',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(PRALL3.OR.HELP.EQ.'STPTOL') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL4) THEN
          WRITE(NUNIT,2)
          WRITE(NUNIT,54)
54        FORMAT(T3,'***',2X,'REAL VECTORS ***',T74,'*')
          WRITE(NUNIT,2)
          WRITE(NUNIT,2)
        END IF
        IF(PRALL.OR.PRALL4.OR.HELP.EQ.'BOUNDL') THEN
          WRITE(NUNIT,55)
55        FORMAT(T3,'**',1X,'BOUNDL **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'LOWER BOUNDS FOR THE COMPONENTS.',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: -10**MAXEXP',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: MAXEXP,BOUNDU',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'BOUNDL') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL4.OR.HELP.EQ.'BOUNDU') THEN
          WRITE(NUNIT,56)
56        FORMAT(T3,'**',1X,'BOUNDU **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'UPPER BOUNDS FOR THE COMPONENTS.',T74,'*',
     $    /T3,'*',T74,'*',/T3,'*',2X,'DEFAULT VALUE: 10**MAXEXP',
     $    T74,'*',/T3,'*',T74,'*',/T3,'*',2X,
     $    'CROSS-REFERENCE: MAXEXP,BOUNDL',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'BOUNDU') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL4.OR.HELP.EQ.'SCALEF') THEN
          WRITE(NUNIT,57)
57        FORMAT(T3,'**',1X,'SCALEF **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'SCALING FACTORS FOR THE FUNCTIONS. THESE ARE',
     $    ' INVERSELY',T74,'*',/T3,'*',2X,'PROPORTIONAL TO TYPICAL',
     $    ' VALUES FOR EACH OF THE FUNCTIONS.',T74,'*',/T3,'*',T74,
     $    '*',/T3,'*',2X,'DEFAULT VALUE: 1.0D0',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'SCALEF') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL4.OR.HELP.EQ.'SCALEX') THEN
          WRITE(NUNIT,58)
58        FORMAT(T3,'**',1X,'SCALEX **',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'SCALING FACTORS FOR THE COMPONENTS. THESE ARE',
     $    ' INVERSELY',T74,'*',/T3,'*',2X,'PROPORTIONAL TO TYPICAL',
     $    ' VALUES FOR EACH OF THE COMPONENTS.',T74,'*',/T3,'*',T74,
     $    '*',/T3,'*',2X,'DEFAULT VALUE: 1.0D0',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP.EQ.'SCALEX') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL4.OR.HELP(1:2).EQ.'XC') THEN
          WRITE(NUNIT,59)
59        FORMAT(T3,'**',1X,'XC **',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'CONTAINS INITIAL ESTIMATE ON ENTRY.',T74,'*',/T3,'*',
     $    T74,'*',/T3,'*',2X,'DEFAULT VALUE: GIVEN BY USER',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(HELP(1:2).EQ.'XC') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
        IF(PRALL.OR.PRALL4.OR.HELP(1:5).EQ.'XPLUS') THEN
          WRITE(NUNIT,60)
60        FORMAT(T3,'**',1X,'XPLUS **',T74,'*',/T3,'*',T74,'*',/T3,'*',
     $    2X,'LATEST ESTIMATE ON RETURN.',T74,'*',/T3,'*',T74,'*',
     $    /T3,'*',2X,'DEFAULT VALUE: N/A (OUTPUT)',T74,'*')
          ERR=.FALSE.
          WRITE(NUNIT,2)
          IF(PRALL.OR.PRALL4.OR.HELP(1:5).EQ.'XPLUS') THEN
            WRITE(NUNIT,1)
            RETURN
          END IF
        END IF
C
C       CHECK FOR INCORRECT INPUT INTO HELP FACILITY.
C
        IF(ERR) THEN
           WRITE(NUNIT,2)
           WRITE(NUNIT,61) HELP
61         FORMAT(T3,'*',2X,'INCORRECT INPUT TO HELP FACILITY: ',A,
     $     T74,'*')
           WRITE(NUNIT,2)
           WRITE(NUNIT,1)
        END IF
C
C       LAST CARD OF SUBROUTINE OLHELP.
C
        END

