        SUBROUTINE QMIN(NUNIT,OUTPUT,DELFTS,DELTA,DELTAF,STPLEN)
C
C       FEB. 9, 1991
C
C       SET THE NEW TRUST REGION SIZE, DELTA, BASED ON A QUADRATIC
C       MINIMIZATION WHERE DELTA IS THE INDEPENDENT VARIABLE.
C
C       DELTAF IS THE DIFFERENCE IN THE SUM-OF-SQUARES OBJECTIVE
C       FUNCTION VALUE AND DELFTS IS THE DIRECTIONAL DERIVATIVE IN
C       THE DIRECTION OF THE CURRENT STEP, S, WHICH HAS STEP LENGTH
C       STPLEN.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        INTEGER  OUTPUT
        DATA ZERO,POINT1,TWO /0.0D0,0.1D0,2.0D0/
C
        IF(DELTAF-DELFTS.NE.ZERO) THEN
C
C          CALCULATE DELTA WHERE MINIMUM WOULD OCCUR - DELTMP.
C          THIS IS PROVISIONAL AS IT MUST BE WITHIN CERTAIN
C          LIMITS TO BE ACCEPTED.
C
           DELTMP=-DELFTS*STPLEN/(TWO*(DELTAF-DELFTS))
           IF(OUTPUT.GT.4) THEN
              WRITE(NUNIT,1)
1             FORMAT(T3,'*',T74,'*')
              WRITE(NUNIT,2) DELTMP
2             FORMAT(T3,'*',7X,'TEMPORARY DELTA FROM QUADRATIC',
     $        ' MINIMIZATION: ',1PD12.3,T74,'*')
              WRITE(NUNIT,3) DELTA
3             FORMAT(T3,'*',30X,'VERSUS CURRENT DELTA: ',1PD12.3,
     $        T74,'*')
           END IF
C
C          REDUCE DELTA DEPENDING ON THE MAGNITUDE OF DELTMP.
C          IT MUST BE WITHIN [.1DELTA,.5DELTA] TO BE ACCEPTED -
C          OTHERWISE THE NEAREST ENDPOINT OF THE INTERVAL IS USED.
C
           IF(DELTMP.LT.POINT1*DELTA) THEN
              DELTA=POINT1*DELTA
              IF(OUTPUT.GT.4) THEN
                 WRITE(NUNIT,1)
                 WRITE(NUNIT,4)
4                FORMAT(T3,'*',7X,'NEW DELTA SET TO 0.1',
     $           ' CURRENT DELTA',T74,'*')
              END IF
           ELSEIF(DELTMP.GT.DELTA/TWO) THEN
              DELTA=DELTA/TWO
              IF(OUTPUT.GT.4) THEN
                 WRITE(NUNIT,1)
                 WRITE(NUNIT,5)
5                FORMAT(T3,'*',7X,'NEW DELTA SET TO 0.5',
     $           ' CURRENT DELTA',T74,'*')
              END IF
           ELSE
              DELTA=DELTMP
              IF(OUTPUT.GT.4) THEN
                 WRITE(NUNIT,1)
                 WRITE(NUNIT,6)
6                FORMAT(T3,'*',7X,'NEW DELTA SET TO DELTMP',T74,'*')
              END IF
           END IF
        ELSE
           IF(OUTPUT.GT.4) THEN
              WRITE(NUNIT,1)
              WRITE(NUNIT,7)
7             FORMAT(T3,'*',7X,'TO AVOID OVERFLOW NEW DELTA',
     $        ' SET TO 0.5 CURRENT DELTA',T74,'*')
           END IF
           DELTA=DELTA/TWO
        END IF
        RETURN
C
C       LAST CARD OF SUBROUTINE QMIN.
C
        END
