        SUBROUTINE QRDCOM(QRSING,N,EPSMCH,A,HHPI,RDIAG)
C
C       FEB. 23, 1992
C
C       THIS SUBROUTINE COMPUTES THE QR DECOMPOSITION OF THE
C       MATRIX A.  THE DECOMPOSITION IS COMPLETED EVEN IF
C       A SINGULARITY IS DETECTED (WHEREUPON QRSING IS SET TO
C       TRUE).
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION  A(N,N)   ,HHPI(N) ,RDIAG(N)
        LOGICAL    QRSING
        DATA ZERO /0.0D0/
C
        QRSING=.FALSE.
C
        DO 100 K=1,N-1
           ETA=ZERO
           DO 200 I=K,N
              ETA=MAX(ETA,ABS(A(I,K)))
200        CONTINUE
           IF(ETA.LT.EPSMCH) THEN
              QRSING=.TRUE.
              HHPI(K)=ZERO
              RDIAG(K)=ZERO
           ELSE
              DO 300 I=K,N
                 A(I,K)=A(I,K)/ETA
300           CONTINUE
              SIGMA=ZERO
              DO 400 I=K,N
		  SIGMA=SIGMA+A(I,K)*A(I,K)
400           CONTINUE
              SIGMA=SIGN(SQRT(SIGMA),A(K,K))
              A(K,K)=A(K,K)+SIGMA
              HHPI(K)=SIGMA*A(K,K)
              RDIAG(K)=-ETA*SIGMA
              DO 500 J=K+1,N
                 TAU=ZERO
                 DO 600 I=K,N
                    TAU=TAU+A(I,K)*A(I,J)
600              CONTINUE
                 TAU=TAU/HHPI(K)
                 DO 700 I=K,N
                    A(I,J)=A(I,J)-TAU*A(I,K)
700              CONTINUE
500           CONTINUE
           END IF
100     CONTINUE
        RDIAG(N)=A(N,N)
        IF(ABS(RDIAG(N)).LT.EPSMCH) QRSING=.TRUE.
        RETURN
C
C       LAST CARD OF SUBROUTINE QRDCOM.
C
        END
