        SUBROUTINE QRSOLV(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,
     $                    OUTPUT,A     ,HHPI  ,RDIAG ,B     )
C
C       FEB. 2, 1991
C
C       THIS SUBROUTINE SOLVES
C
C            (QR)X=B
C
C            WHERE  Q AND R ARE OBTAINED FROM THE QR DECOMPOSITION
C                   B IS A GIVEN RIGHT HAND SIDE WHICH IS
C                     OVERWRITTEN
C
C                   R IS CONTAINED IN THE STRICT UPPER TRIANGLE OF
C                     MATRIX A AND THE VECTOR RDIAG
C                   Q IS "CONTAINED" IN THE LOWER TRIANGLE OF MATRIX A
C
C       FRSTOV  INDICATES FIRST OVERFLOW - USED ONLY TO SET BORDER
C               FOR OUTPUT
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        INTEGER    OUTPUT
        DIMENSION  A(N,N)  ,HHPI(N)  ,B(N)   ,RDIAG(N)
        LOGICAL    FRSTOV  ,OVERCH   ,OVERFL ,WRNSUP
        COMMON/NNES_2/WRNSUP
	DATA ZERO,ONE,TEN /0.0D0,1.0D0,10.0D0/
C
	EPS=TEN**(-MAXEXP)
        FRSTOV=.TRUE.
        OVERFL=.FALSE.
C
C       MULTIPLY RIGHT HAND SIDE BY Q^ THEN SOLVE USING R
C       STORED IN MATRIX A.
C
        DO 100 J=1,N-1
	   TAU=ZERO
           DO 200 I=J,N
              IF(OVERCH) THEN
                 IF(LOG10(ABS(A(I,J))+EPS)+LOG10(ABS(B(I))+EPS)
     $              -LOG10(HHPI(J)+EPS).GT.MAXEXP) THEN
                    OVERFL=.TRUE.
		    TAU=SIGN(TEN**MAXEXP,A(I,J))*
     $                  SIGN(ONE,B(J))
                    GO TO 201
                 END IF
              END IF
              TAU=TAU+A(I,J)*B(I)/HHPI(J)
201        CONTINUE
200        CONTINUE
           DO 300 I=J,N
              IF(OVERCH) THEN
                 IF(LOG10(ABS(TAU)+EPS)+LOG10(ABS(A(I,J))+EPS)
     $              .GT.MAXEXP) THEN
                    OVERFL=.TRUE.
		    B(I)=-SIGN(TEN**MAXEXP,TAU)
     $                   *SIGN(ONE,A(I,J))
                    IF(OUTPUT.GT.2.AND.(.NOT.WRNSUP)) THEN
                       IF(FRSTOV) THEN
                          WRITE(NUNIT,1)
1                         FORMAT(T3,'*',T74,'*')
                       END IF
                       WRITE(NUNIT,2) I,B(I)
2                      FORMAT(T3,'*',4X,'WARNING: COMPONENT ',I3,
     $                 ' SET TO ',1PD11.3,' IN QRSOLV BEFORE',
     $                 ' RSOLV',T74,'*')
                    END IF
                    GO TO 301
                 END IF
              END IF
              B(I)=B(I)-TAU*A(I,J)
301           CONTINUE
300        CONTINUE
100     CONTINUE
        CALL RSOLV(OVERCH,OVERFL,MAXEXP,N,NUNIT,OUTPUT,A,RDIAG,B)
        RETURN
C
C       LAST CARD OF SUBROUTINE QRSOLV.
C
	END
