        SUBROUTINE UVMUL(NRADEC,NRAACT,NCDEC ,NCACT ,AMAT  ,BVEC  ,CVEC)
C
C       FEB. 8, 1991
C
C       MATRIX-VECTOR MULTIPLICATION:  AB=C  WHERE A IS UPPER TRIANGULAR
C
C       VERSION WITH INNER LOOP UNROLLED TO DEPTHS 32, 16, 8 AND 4
C       EACH ROW OF MATRIX A IS SAVED AS A COLUMN BEFORE USE.
C
C       NRADEC IS 1ST DIM. OF AMAT; NRAACT IS ACTUAL LIMIT FOR 1ST INDEX
C       NCDEC IS COMMON DIMENSION OF AMAT & BVEC; NCACT IS ACTUAL LIMIT
C
C       I.E. NRADEC IS THE NUMBER OF ROWS OF A DECLARED
C            NCDEC IS THE COMMON DECLARED DIMENSION (COLUMNS OF A AND
C            ROWS OF B)
C
C       MODIFICATION OF THE MATRIX MULTIPLIER DONATED BY PROF. JAMES
C       MACKINNON, QUEEN'S UNIVERSITY, KINGSTON, ONTARIO, CANADA
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION AMAT(NRADEC,NCDEC),  BVEC(NCDEC),  CVEC(NRADEC)
        DATA ZERO /0.0D0/
        DO 100 I=1,NRAACT
C
C          FIND NUMBER OF GROUPS OF SIZE 32, 16 ...
C
           NCC32=(NCACT-(I-1))/32
           NCC32R=(NCACT-(I-1))-32*NCC32
           NCC16=NCC32R/16
           NCC16R=NCC32R-16*NCC16
           NCC8=NCC16R/8
           NCC8R=NCC16R-8*NCC8
           NCC4=NCC8R/4
           NCC4R=NCC8R-4*NCC4
C
C          FIND ENTRY FOR VECTOR C.
C
           SUM=ZERO
           K=I-1
           IF(NCC32.GT.0) THEN
              DO 200 KK=1,NCC32
                 K=K+32
                 SUM=SUM
     $           +AMAT(I,K-31)*BVEC(K-31)+AMAT(I,K-30)*BVEC(K-30)
     $           +AMAT(I,K-29)*BVEC(K-29)+AMAT(I,K-28)*BVEC(K-28)
     $           +AMAT(I,K-27)*BVEC(K-27)+AMAT(I,K-26)*BVEC(K-26)
     $           +AMAT(I,K-25)*BVEC(K-25)+AMAT(I,K-24)*BVEC(K-24)
                 SUM=SUM
     $           +AMAT(I,K-23)*BVEC(K-23)+AMAT(I,K-22)*BVEC(K-22)
     $           +AMAT(I,K-21)*BVEC(K-21)+AMAT(I,K-20)*BVEC(K-20)
     $           +AMAT(I,K-19)*BVEC(K-19)+AMAT(I,K-18)*BVEC(K-18)
     $           +AMAT(I,K-17)*BVEC(K-17)+AMAT(I,K-16)*BVEC(K-16)
                 SUM=SUM
     $           +AMAT(I,K-15)*BVEC(K-15)+AMAT(I,K-14)*BVEC(K-14)
     $           +AMAT(I,K-13)*BVEC(K-13)+AMAT(I,K-12)*BVEC(K-12)
     $           +AMAT(I,K-11)*BVEC(K-11)+AMAT(I,K-10)*BVEC(K-10)
     $           +AMAT(I,K-9)*BVEC(K-9)  +AMAT(I,K-8) *BVEC(K-8)
                 SUM=SUM
     $           +AMAT(I,K-7)*BVEC(K-7)+AMAT(I,K-6)*BVEC(K-6)
     $           +AMAT(I,K-5)*BVEC(K-5)+AMAT(I,K-4)*BVEC(K-4)
     $           +AMAT(I,K-3)*BVEC(K-3)+AMAT(I,K-2)*BVEC(K-2)
     $           +AMAT(I,K-1)*BVEC(K-1)+AMAT(I,K)  *BVEC(K)
200           CONTINUE
           END IF
           IF(NCC16.GT.0) THEN
              DO 300 KK=1,NCC16
                 K=K+16
                 SUM=SUM
     $           +AMAT(I,K-15)*BVEC(K-15)+AMAT(I,K-14)*BVEC(K-14)
     $           +AMAT(I,K-13)*BVEC(K-13)+AMAT(I,K-12)*BVEC(K-12)
     $           +AMAT(I,K-11)*BVEC(K-11)+AMAT(I,K-10)*BVEC(K-10)
     $           +AMAT(I,K-9)*BVEC(K-9)  +AMAT(I,K-8) *BVEC(K-8)
                 SUM=SUM
     $           +AMAT(I,K-7)*BVEC(K-7)+AMAT(I,K-6)*BVEC(K-6)
     $           +AMAT(I,K-5)*BVEC(K-5)+AMAT(I,K-4)*BVEC(K-4)
     $           +AMAT(I,K-3)*BVEC(K-3)+AMAT(I,K-2)*BVEC(K-2)
     $           +AMAT(I,K-1)*BVEC(K-1)+AMAT(I,K)  *BVEC(K)
300           CONTINUE
           END IF
           IF(NCC8.GT.0) THEN
              DO 400 KK=1,NCC8
                 K=K+8
                 SUM=SUM
     $           +AMAT(I,K-7)*BVEC(K-7)+AMAT(I,K-6)*BVEC(K-6)
     $           +AMAT(I,K-5)*BVEC(K-5)+AMAT(I,K-4)*BVEC(K-4)
     $           +AMAT(I,K-3)*BVEC(K-3)+AMAT(I,K-2)*BVEC(K-2)
     $           +AMAT(I,K-1)*BVEC(K-1)+AMAT(I,K)  *BVEC(K)
400           CONTINUE
           END IF
           IF(NCC4.GT.0) THEN
              DO 500 KK=1,NCC4
                 K=K+4
                 SUM=SUM
     $           +AMAT(I,K-3)*BVEC(K-3)+AMAT(I,K-2)*BVEC(K-2)
     $           +AMAT(I,K-1)*BVEC(K-1)+AMAT(I,K)  *BVEC(K)
500           CONTINUE
           END IF
           IF(NCC4R.GT.0) THEN
              DO 600 KK=1,NCC4R
                 K=K+1
                 SUM=SUM+AMAT(I,K)*BVEC(K)
600           CONTINUE
           END IF
           CVEC(I)=SUM
100     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE UVMUL.
C
        END
