// Class definition for the new state variable transient analysis
//
// Author:
//          Carlos E. Christoffersen
//

#ifndef WavTran_h
#define WavTran_h 1

#include "Analysis.h"
//#include "OFunction.h"

// Main class definition follows

class WavTran : public Analysis
{
	public:

  WavTran();

  ~WavTran();

  // The main analysis routine.
  virtual void run(Circuit* cir);

  //Return the name of the element
  static const char* getNetlistName()
  {
     return ainfo.name;
  }

	private:

  Circuit* cir;

  // ------------------- Parameter-related variables

  // Analysis information
  static ItemInfo ainfo;

  // Number of parameters of this element
  static const unsigned n_par;

  // Analysis parameters
  int L, J;
  double tf, tw;
  int max_nw;
  bool saveMNAM, stop;
  int nsteps, permc_spec;

  // Parameter information
  static ParmInfo pinfo[];
};

#endif

