//  Ideal mixer
//
//  Author:
//  Mark Buff


#ifndef AbmMixer_h
#define AbmMixer_h 1

class AbmMixer : public AdolcElement
{
	public:

  AbmMixer(const string& iname);

  ~AbmMixer() {}

  static const char* getNetlistName()
  {
    return einfo.name;
  }

  // Do some local initialization
  virtual void init() throw(string&);

	private:

  virtual void eval(adoublev& x, adoublev& vp, adoublev& ip);

  // Element information
  static ItemInfo einfo;

  // Number of parameters of this element
  static const unsigned n_par;

  // Parameter variables
  int op;
  int inputs;

  // Parameter information
  static ParmInfo pinfo[];

};

#endif

