#!bash
#
# This script generates the files:
#                                 element_headers.h
#                                 create_dummy_elem.cc
#                                 create_element.cc

# establish the COUNT variable
COUNT=0
for ELEM in $*; do
    let COUNT=COUNT+1;
done

# -----------
# create "element_headers.h"
# -----------
cat > element_headers.h <<EOF
//
// This file is generated automatically. Do no edit it. 
//
// List of all element headers.
//

#ifndef e_headers_h
#define e_headers_h 1

EOF

echo "#define ELEM_TYPES "$COUNT >> element_headers.h
echo >> element_headers.h

for ELEM in $*; do
    echo "#include \""$ELEM".h\"" >> element_headers.h;
done

echo >> element_headers.h
echo "#endif" >> element_headers.h


# -----------
# Create file "create_dummy_elem.cc" and count the number of elements
# -----------
cat > create_dummy_elem.cc <<EOF
// 
// This file is automatically generated. Do not edit it.
//
// List of primitive element of each type used by ElementManager
//

EOF

# reset the count variable and increment again
COUNT=0
for ELEM in $*; do
    ELEMTEMP="${ELEM/*src\//}"
    echo "elem_vector["$COUNT"] = new "$ELEMTEMP"(\"dummy\");" >> create_dummy_elem.cc;
    let COUNT=COUNT+1;
done


# -----------
# Create "create_element.cc"
# -----------
cat > create_element.cc <<EOF
// 
// This file is automatically generated. Do not edit it.
//
// This code creates a given element instance given the element name.
//

EOF

for ELEM in $*; do
    ELEMTEMP="${ELEM/*src\//}"
    echo "if (elem_type == "$ELEMTEMP"::getNetlistName())" >> create_element.cc;
    echo "  new_elem = new "$ELEMTEMP"(iname);" >> create_element.cc;
done

echo >> create_element.cc
