#include "../freeda_mtl.h"

// Now define some handy global constants
const double zero = 0.;
const double one = 1.;
const double_complex Czero(zero, zero);
const double_complex Cone(one, zero);
const double pi = 3.14159265358979323846;
const double twopi = pi * 2.;
const double deg2rad = pi / 180.;
// Boltzman constant
const double kBoltzman = 1.3806266e-23;
// Electron charge
const double eCharge = 1.6021918e-19;
// Permittivity of free space
const double epsilon0 = 8.854194e-12;
// Permeability of free space
const double mu0 = pi * 4e-7;
// Speed of light in free space
const double c0 = 2.998633e+08;

